; **************************************************************************** 
; ** DEMO CS-GRID V2.3 *** (c) 2005-2006 Christian Walde-Sauer, 27.10.2005 *** 
; **************************************************************************** 
; * Last Edit 07.09.2006                                                     * 
; * Demo-Routing for multiple Edit-Grid-Gadgets with extended functionality  * 
; * Runs with PB 4.x only                                                    * 
; **************************************************************************** 
; * This product is under license: GNU and delivered as it is                *
; * It is not allowed to change code of this library                         *
; ****************************************************************************
; * Naming author on credits would be recommended                            *
; ****************************************************************************
; * If you want to donate, please contact cws@xideas.de                      *
; ****************************************************************************
; * Requires PB4 (since Version V2.2)                                        *
; ****************************************************************************
; * Source: http://www.xideas.de/purebasic/CS-Grid2-3-PB4-Source.zip         *
; ****************************************************************************



; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; !! REMOVE THIS IN CASE OF USERLIB        !!
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

XIncludeFile "CS-Grid2-3.pb"                     ; Adds Grid-Gadget-Library (should be done automatically in case of a UserLib
CSGridGadget_Init()                               ; Runs the "AutoRun" of the Library manually in case of a non UserLib

; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; !! END OF REMOVE THIS IN CASE OF USERLIB !!
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


; Additional information: 
; - Contains no special Windows library commands, should be runable on windows/linux/macosx (some additional features unsupported)
; - Multiple customizing commands (colors, designs, etc.) 
; - Free to be used for own projects (mentioned in credits would be recommended), delivered as it is 


CSGrid_WindowID = 0
wStyle = #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered
hWnd = OpenWindow(CSGrid_WindowID,0,0,800,400,"TEST-Grid",wStyle)

If hWnd 
  CreateGadgetList(WindowID(CSGrid_WindowID)) 


  ; ******************************************************
  ; * SOMETHING UNIQUE: A GRID INSIDE A GRID             *
  ; ******************************************************
  
  ; PLEASE NOTE:
  ; TO SOLVE A Z-ORDER PROBLEM IN MS WINDOWS-EVENT-CHAIN, YOU NEED TO CREATE YOUR SUB-OBJECTS FIRST
  ; ELSE YOU ARE NOT ABLE TO CLICK ON F.EX. SCROLLBARS
  
  test2 = CSGridGadget(#PB_Any,0,0,600,100,10,5)          ; Creates a CS-Grid-Gadget (called Grid 2 - Child)

  CSGridGadget_SetAutoRedraw(test2,-1)                    ; Turns of Auto-Redraw for Grid 2 for faster setup
  For y = 0 To 4
    For x = 0 To 9
      CSGridGadget_SetCellValue(test2,x,y,Str((y*10)+x+1)); Fills Grid 2 with content 
    Next
  Next
  CSGridGadget_SetColCaptionVisibility(test2,1)           ; Shows a column header (default empty caption) of Grid 2
  CSGridGadget_SetRowCaptionVisibility(test2,1)           ; Shows a row header (default numbered caption) of Grid 2
  For x = 0 To 9
    CSGridGadget_SetColCaption(test2,x,Chr(65+x))         ; Defines custom header Labels for all Columns of Grid 2
  Next
    
  CSGridGadget_SetColWidth(test2,2,150)                   ; Defines Column-Width for Column 2 of Grid 2
  CSGridGadget_SetColWidth(test2,3,200)                   ; Defines Column-Width for Column 3 of Grid 2
  CSGridGadget_SetColWidth(test2,1,-1)                    ; Defines Column 1 as hidden of Grid 2
  CSGridGadget_SetColDataType(test2,2,#CSGRID_DataType_EUR)                 ; Defines Column-Type "EUR" for Column 2 of Grid 2
  CSGridGadget_SetColUserNumberFormat(test2,3,"#.###.##0,00 GBP") ; Defines User-Output-Type for Column 3 of Grid 2 
  CSGridGadget_SetColSummary(test2,3,1)                   ; Defines Column-Summary for Column 3 of Grid 2
  CSGridGadget_SetCellValue(test2,3,2,"1221.1023")        ; Defines new Content for Cell C:3 R:2 of Grid 2
  CSGridGadget_SetCellValue(test2,2,2,"No Access")        ; Defines new Content for Cell C:2 R:2 of Grid 2
  CSGridGadget_SetCellLockStatus(test2,2,2,-16)           ; Locks Cell C:2 R:2 for access (and input) of Grid 2
  CSGridGadget_SetCellValue(test2,3,3,"No Edit")          ; Defines new Content for Cell C:3 R:3 of Grid 2
  CSGridGadget_SetCellLockStatus(test2,3,3,-1)            ; Locks Cell C:3 R:3 for input of Grid 2
  CSGridGadget_SetAutoRedraw(test2,1)                     ; Turns of Auto-Redraw for Grid 2 to visualize grid-updates

  ; ******************************************************
  ; * END OF SOMETHING UNIQUE: A GRID INSIDE A GRID      *
  ; ******************************************************
  
  test = CSGridGadget(#PB_Any,10,10,743,300,10,5) ; Creates a CS-Grid-Gadget (called Grid 1 - Parent)
  CSGridGadget_SetAutoRedraw(test,-1)             ; Turns off Auto-Redraw for Grid 1 for faster setup 

  CSGridGadget_SetColCaptionVisibility(test,1)    ; Shows a column header (default empty caption) 
  CSGridGadget_SetColCaption(test,0,"String")     ; Defines custom header Label for column 0
  CSGridGadget_SetColCaption(test,1,"Long")       ; Defines custom header Label for column 1
  CSGridGadget_SetColCaption(test,2,"Float")      ; Defines custom header Label for column 2
  CSGridGadget_SetColCaption(test,3,"Formatted")  ; Defines custom header Label for column 3
  CSGridGadget_SetColCaption(test,4,"Percentage") ; Defines custom header Label for column 4
    
  CSGridGadget_SetColCaptionOrientation(test,4,#CSGRID_Orient_Right) ; Defines custom header orientation "RIGHT" for column 4
  CSGridGadget_SetColCaption(test,5,"US Dollars") ; Defines custom header Label for column 5
  CSGridGadget_SetColCaption(test,6,"User Fmt")   ; Defines custom header Label for column 6
  CSGridGadget_SetColCaption(test,7,"Checkbox")   ; Defines custom header Label for column 7
  CSGridGadget_SetColCaption(test,8,"Date")       ; Defines custom header Label for column 8
  CSGridGadget_SetColCaption(test,9,"Images")     ; Defines custom header Label for column 9
  
  CSGridGadget_SetRowCaptionVisibility(test,1)    ; Shows a row header (default numbered caption) 

  CSGridGadget_SetColWidth(test,2,100)            ; Defines Column-Width for Column 2 
  CSGridGadget_SetColWidth(test,3,100)            ; Defines Column-Width for Column 3 
  CSGridGadget_SetColWidth(test,4,100)            ; Defines Column-Width for Column 4 
  CSGridGadget_SetColWidth(test,5,100)            ; Defines Column-Width for Column 5 
  CSGridGadget_SetColWidth(test,6,100)            ; Defines Column-Width for Column 6 
  CSGridGadget_SetColWidth(test,8,90)             ; Defines Column-Width for Column 8
  
  CSGridGadget_SetColColorBack(test,5,RGB(255,220,220)) ; Defines a new Background-Color to Column 5
  CSGridGadget_SetRowColorBack(test,1,RGB(220,255,220)) ; Defines a new Background-Color to Row 1

  CSGridGadget_SetColDataType(test,0,#CSGRID_DataType_Text)           ; Defines Output-Type to Text for Column 0 
  CSGridGadget_SetCellValue(test,0,0,"TESTING")   ; Defines new Content for Cell C:0 R:0 
  CSGridGadget_SetColInputType(test,0,#CSGRID_Input_Rollup) ; Defines Input via Rollup (values-list) for Column 0
  CSGridGadget_SetColInputRessource(test,0,"Input 1"+Chr(13)+Chr(10)+"Input 2"+Chr(13)+Chr(10)+"Input 3") ; Defines a values list with 3 values (separated with CHR(13)+CHR(10)) for Column 0
  
  CSGridGadget_SetCellValue(test,1,0,"5")         ; Defines new Content for Cell C:1 R:0  
  CSGridGadget_SetColInputType(test,1,#CSGRID_Input_Spin) ; Defines Input via Spin for Column 1
  CSGridGadget_SetColDataType(test,1,#CSGRID_DataType_Int)           ; Defines Output-Type to Long for Column 1 
  CSGridGadget_SetColInputMinMax(test,1,0,10)     ; Defines Min/Max-Value for input for Column 1
  
  CSGridGadget_SetColDataType(test,2,#CSGRID_DataType_Float)          ; Defines Output-Type to Float for Column 2 
  CSGridGadget_SetCellValue(test,2,0,"139.6548")  ; Defines new Content for Cell C:2 R:0  
  CSGridGadget_SetColSummary(test,2,1)            ; Defines Column-Summary for Column 2

  CSGridGadget_SetColDataType(test,3,#CSGRID_DataType_F2Dig)          ; Defines Output-Type to Formatted Fload, 2 decimals places for Column 3
  CSGridGadget_SetCellValue(test,3,0,"1221.105")  ; Defines new Content for Cell C:3 R:0  
  
  CSGridGadget_SetColDataType(test,4,#CSGRID_DataType_Percent)          ; Defines Output-Type to Percentage, 4 decimals places for Column 4
  CSGridGadget_SetCellValue(test,4,0,"0.456789")  ; Defines new Content for Cell C:4 R:0  

  ;CSGridGadget_SetFormatComma(test,".")          ; Enables support for US/UK-style comma-symbol
  CSGridGadget_SetColDataType(test,5,#CSGRID_DataType_USD)          ; Defines Output-Type to US Dollars, 2 decimals places for Column 5
  CSGridGadget_SetCellValue(test,5,0,"150286")    ; Defines new Content for Cell C:5 R:0  

  CSGridGadget_SetColDataType(test,6,#CSGRID_DataType_User)         ; Defines a user defined Output-Type for Column 6
  CSGridGadget_SetColUserNumberFormat(test,6,"#######0.00") ; Defines User-Output-Type for Column 6 
  CSGridGadget_SetCellValue(test,6,0,"1502.86")   ; Defines new Content for Cell C:6 R:0  

  CSGridGadget_SetColDataType(test,7,#CSGRID_DataType_Bool)           ; Defines Output-Type to Boolean for Column 7
  CSGridGadget_SetCellLockStatus(test,7,2,-16)    ; Locks Cell C:7 R:2 for access (and input) 

  CSGridGadget_SetCellValue(test,8,0,"5")         ; Defines new Content for Cell C:8 R:0  
  CSGridGadget_SetColInputType(test,8,#CSGRID_Input_Date) ; Defines Input via Date for Column 8
  CSGridGadget_SetColUserNumberFormat(test,8,"%dd.%mm.%yyyy") ; Defines User-Output-Type "DATE" for Column 8
  CSGridGadget_SetColDataType(test,8,#CSGRID_DataType_Date)           ; Defines Output-Type to Date/Time for Column 8

  ; Just only supported by Windows
  image = LoadImage(#PB_Any,"test.bmp")
  CSGridGadget_SetCellValue(test,9,0,Str(image))  ; Defines new Content for Cell C:9 R:0  
  CSGridGadget_SetColDataType(test,9,#CSGRID_DataType_Pic)           ; Defines Output-Type to Picture for Column 9

  CSGridGadget_SetRowHeight(test,3,40)            ; Defines individual Row-Height for Row 3


  ; Lets do some changes in the current layout:

  CSGridGadget_SetCellValue(test,2,1,"No Value")  ; Defines new Content for Cell C:2 R:1 
  
  CSGridGadget_SetCellLockStatus(test,2,2,-16)    ; Locks Cell C:2 R:2 for access (and input) 

  CSGridGadget_SetCellValue(test,3,3,"No Edit")   ; Defines new Content for Cell C:3 R:3 (this is a number column, so there should be a value "0" displayed)

  CSGridGadget_SetCellLockStatus(test,3,3,-1)     ; Locks Cell C:3 R:3 for input 
  CSGridGadget_SetColsUserSort(test,1)            ; Activates user sorting via double-click on column headder

  ;test2 = StringGadget(#PB_Any,0,0,200,50,"This is a tes for a line sub-level gadget")
  ;CSGridGadget_SetRowDetailsHandle(test,2,test2,100) ; Links an object or object-container or CSGridGadget as a sub-component to row 2 of CS-Grid-Gadget

  
  CSGridGadget_SetRowDetailsHandle(test,2,test2,100,1) ; Links an object (here: grid 2) as a sub-component to row 2 of Grid 1
  CSGridGadget_SetRowDetailsEnabled(test,1)       ; Enables showing row details / row sub-container

  CSGridGadget_SetColsScaleable(test,1)           ; Enables column scaling by drag'n'drop (there is no special mouse-cursor by default) to Grid 1
  
  CSGridGadget_SetFocus(test)                     ; Sets focus to the Grid 1
  CSGridGadget_SetAutoRedraw(test,1)              ; Turns on Auto-Redraw for Grid 1 to visualize grid-updates
  
  ; Add some shortcuts for copy and paste 
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Control | #PB_Shortcut_C , 1)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Control | #PB_Shortcut_V , 2)
  
  Repeat 
    main_EventID = WaitWindowEvent() 
    main_MenuEventID = EventMenu()
    Select main_EventID 
      Case #PB_Event_SizeWindow 
        CSGridGadget_Resize(test,10,10,743,300) ; Resizes Grid 1 
      Default 
        CSevent = CSGridGadget_EventHandling(main_EventID,main_MenuEventID); Processes all Grid-Gadget events (for all CS-Grid-Gadgets) 
        Select CSevent ; Possible CS-Grid events:
          Case #CSGRID_Event_ScrollH ; H-Scroll
            Debug "H-scrolled"
          Case #CSGRID_Event_ScrollV ; V-Scroll 
            Debug "V-scrolled"
          Case #CSGRID_Event_InputNo ; Tried to input, but cell is locked for input
            Debug "No input possible"
          Case #CSGRID_Event_InputStart ; Start input
            Debug "Input started"
          Case #CSGRID_Event_InputEnd ; End input
            Debug "Input accepted"
          Case #CSGRID_Event_InputCancel ; Cancel input
            Debug "Input cancelled"
          Case #CSGRID_Event_CellSelect ; Select new cell          
            ;CSGridGadget_EventExecute(test,#CSGRID_Event_InputStart) ; If you enable this function, you would jump into edit mode direct after accessing a cell
          Case #CSGRID_Event_DetailsClosed ; Details closed
            Debug "Details closed"
          Case #CSGRID_Event_DetailsOpened ; Details opened
            Debug "Details opened"
        EndSelect
    EndSelect
    If main_EventID = #PB_Event_Menu
      Select main_MenuEventID
        Case 1 ; Ctrl + C
          CSGridGadget_CopySelectionToClipboard(CSGridGadget_GetActualGrid())
        Case 2 ; Ctrl + V
          CSGridGadget_PasteClipboardToSelection(CSGridGadget_GetActualGrid())
      EndSelect
    EndIf
  Until main_EventID = #PB_Event_CloseWindow 
EndIf
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 16
; Folding = -
; EnableXP
; EnableOnError