; ***********************************************************************
; ** CS-GRID V2.3.1 *** (c)2005-2008 Christian Walde-Sauer, 27.10.2005 **
; ***********************************************************************
; * Last Edit 16.06.2008                                                *
; ***********************************************************************
; ** Compatible with PB 4.x (tested with PB 4.20 x86/Win32)            **
; * This file contains the core-functions of CS-GRID                    *
; ***********************************************************************
; * ProcedureDLL-Functions are public for use in your program           *
; ***********************************************************************
; * This is a GRID-Object for displaying data, incl. sub-objects        *
; * This Code is not using any Windows API-calls, and should be         *
; * compatible with PB4 on Windows, Linux, MacOS X                      *
; * (with some limits on Linux and MacOS X)                             *
; ***********************************************************************
; * This product is under license: GNU and delivered as it is           *
; * It is not allowed to change code of this library                    *
; ***********************************************************************
; * Naming author on credits would be recommended                       *
; ***********************************************************************
; * If you want to donate, please contact cws@xideas.de                 *
; ***********************************************************************
; * Requires PB4 (since Version V2.2)                                   *
; ***********************************************************************
; * Source: http://www.xideas.de/purebasic/CS-Grid2-3-PB4-Source.zip    *
; ***********************************************************************



; *************************************************************
;- Constants / Konstanten
; *************************************************************

#LF_FACESIZE = 32 ; This is been used for tailbite (should come with PB already)


; PUBLIC CONSTANTS / ffentliche Konstanten

#CSGRID_Event_ScrollH = 16
#CSGRID_Event_ScrollV = 17
#CSGRID_Event_InputNo = 31
#CSGRID_Event_InputStart = 32
#CSGRID_Event_InputEnd = 33
#CSGRID_Event_InputCancel = 34
#CSGRID_Event_CellSelect = 64
#CSGRID_Event_DetailsClosed = 95
#CSGRID_Event_DetailsOpened = 97

#CSGRID_Input_Text = 0
#CSGRID_Input_Spin = 16
#CSGRID_Input_Date = 17
#CSGRID_Input_IP = 18
#CSGRID_Input_Trackbar = 19
#CSGRID_Input_Rollup = 32
#CSGRID_Input_Combo = 34

#CSGRID_Orient_Left = 0
#CSGRID_Orient_Right = 1
#CSGRID_Orient_Center = 2

#CSGRID_DataType_Text = 0
#CSGRID_DataType_Int = 1
#CSGRID_DataType_Bool = 2
#CSGRID_DataType_Date = 3
#CSGRID_DataType_Pic = 4
#CSGRID_DataType_Float = 16
#CSGRID_DataType_F2Dig = 17 ; Float rounded to 2 digits
#CSGRID_DataType_EUR = 32
#CSGRID_DataType_USD = 33
#CSGRID_DataType_Percent = 64
#CSGRID_DataType_User = 127


; INTERNAL CONSTANTS / Interne Konstanten

#EventID_Return = 98                    ; Ereignis-Kennung fr die Return-Taste
#EventID_ESC = 99                       ; Ereignis-Kennung fr die ESC-Taste
#EventID_Left = 100                     ; Ereignis-Kennung fr die Pfeil-Links-Taste
#EventID_Up = 101                       ; Ereignis-Kennung fr die Pfeil-Hoch-Taste
#EventID_Right = 102                    ; Ereignis-Kennung fr die Pfeil-Rechts-Taste
#EventID_Down = 103                     ; Ereignis-Kennung fr die Pfeil-Runter-Taste
#EventID_SLeft = 104                    ; Ereignis-Kennung fr die Umschalt + Pfeil-Links-Taste
#EventID_SUp = 105                      ; Ereignis-Kennung fr die Umschalt + Pfeil-Hoch-Taste
#EventID_SRight = 106                   ; Ereignis-Kennung fr die Umschalt + Pfeil-Rechts-Taste
#EventID_SDown = 107                    ; Ereignis-Kennung fr die Umschalt + Pfeil-Runter-Taste
#EventID_Space = 108                    ; Ereignis-Kennung fr die Leertaste
#ScrollbarSize = 20                     ; Breite/Hhe der Scrollbars
#DefGridWidth = 72                      ; Standard-Zellenbreite
#DefGridHeight = 22                     ; Standard-Zellenhhe
#DefColor_Grid = $BBBBBB                ; Standardfarbe fr das Gitternetz
#DefColor_Backgr = $999999              ; Standardfarbe fr den Hintergrund
#DefColor_CellBack = $FFFFFF            ; Standardfarbe fr den Zellenhintergrund
#DefColor_CaptBack = $BBFFFF            ; Standardfarbe fr den berschrift/Beschriftungs-Hintergrund
#DefColor_CaptFocus = $A0FFFF           ; Standardfarbe fr den berschrift/Beschriftungs-Hintergrund, bei Fokus-Erhalt einer enthaltenen Zelle
#DefColor_CellLoFoc = $DFDF80           ; Standardfarbe fr den Zellhintergrund bei Fokus-Erhalt und Sperr-Zustand -1
#DefColor_CellFore = $000000            ; Standardfarbe fr den Zelleninhalt (Text)
#DefColor_CellFocus = $FFFF00           ; Standardfarbe fr den Zellenhintergrund bei Fokus-Erhalt
#DefColor_CellLock = $E0E0E0            ; Standardfarbe fr den Zellenhintergrund, wenn Zelle gesperrt ist
#DefColor_CellFocusInact = $FFFFDD      ; Standardfarbe fr den Zellhintergrund der aktiven Zelle, wenn Grid nicht fokusiert ist
#DefColor_ColSumSymbol = $AADDDD        ; Standardfarbe fr das Spalten-Summen-Zeichen
#DefColor_Symbols = $AADDDD             ; Standardfarbe fr das Spalten-Sortierungs-Zeichen
#DefGridVisible = 1                     ; Standardmig werden Gitternetz-Linien angezeigt
#DefColCaptVisible = -1                 ; Standardmig werden Spaltenberschriften nicht mit angezeigt
#DefRowCaptVisible = -1                 ; Standardmig werden Zeilenberschriften nicht mit angezeigt
#DefColCaptWidth = 50                   ; Standardmige Spaltenbreite fr die Zeilenberschrift

; **************************************************************
;- Structures / Strukturen
; **************************************************************


Structure CHARFORMAT2_ 
  cbSize.l                      ; Long    => Enthlt Zeichengre 
  dwMask.l                      ; Long    =>
  dwEffects.l                   ; Long    =>
  yHeight.l                     ; Long    =>
  yOffset.l                     ; Long    =>
  crTextColor.l                 ; Long    => Enthlt die Textfarbe (im RGB-Format)
  bCharSet.b                    ; Byte    =>
  bPitchAndFamily.b             ; Byte    =>
  szFaceName.b[#LF_FACESIZE]    ; Byte    =>
  _wPad2.w                      ; Word    =>
  wWeight.w                     ; Word    =>
  sSpacing.w                    ; Word    => Enthlt Zeichenabstand
  crBackColor.l                 ; Long    => Enthlt die Hintergrundfarbe
  lcid.l                        ; Long    =>
  dwReserved.l                  ; Long    =>
  sStyle.w                      ; Word    =>
  wKerning.w                    ; Word    =>
  bUnderlineType.b              ; Byte    => Enthlt den Type des Text-Unterstreichens
  bAnimation.b                  ; Byte    =>
  bRevAuthor.b                  ; Byte    =>
  bReserved1.b                  ; Byte    =>
EndStructure 


Structure CSGrid_Type
  hGadget.l                     ; Long    => Handle des Container-Objektes
  hImage.l                      ; Long    => Handle fr das Image
  hImageGadget.l                ; Long    => Handle fr das Image-Gadget-Objekt
  hHscrollGadget.l              ; Long    => Handle fr das horizontale Scroll-Gadget-Objekt
  hVscrollGadget.l              ; Long    => Handle fr das vertikale Scroll-Gadget-Objekt
  hInput.l                      ; Long    => Handle fr das Eingabefeld "Text"
  Left.w                        ; Word    => X-Position des Grid-Objektes (relativ zum Parent)
  Top.w                         ; Word    => Y-Position des Grid-Objektes (relativ zum Parent)
  LeftAbs.w                     ; Word    => Absolute X-Position zum Fenster
  TopAbs.w                      ; Word    => Absolute Y-Position zum Fenster
  Width.w                       ; Word    => Breite des Grid-Objektes
  Height.w                      ; Word    => Hhe des Grid-Objektes
  DefGridWidth.w                ; Word    => Standard-Spaltenbreite
  DefGridHeight.b               ; Word    => Standard-Spaltenhhe
  ImgWidth.w                    ; Word    => Breite des Zeichenbereiches
  ImgHeight.w                   ; Word    => Hhe des Zeichenbereiches
  Cols.b                        ; Byte    => Anzahl der Spalten (+ 128 = 0 bis 255)
  Rows.w                        ; Word    => Anzahl der Zeilen (+32768 = 0 bis 65535)
  ScrollX.b                     ; Byte    => Scrollposition in der Spalte
  ScrollY.w                     ; Word    => Scrollposition in der Zeile
  ActColStart.b                 ; Byte    => Aktuelle Spalte (des Cursors, Startpos bei Bereich)
  ActRowStart.w                 ; Word    => Aktuelle Zeile (des Cursors, Startpos bei Bereich)
  ActColEnd.b                   ; Byte    => Aktuelle Spalte (des Cursors, Endpos bei Bereich)
  ActRowEnd.w                   ; Word    => Aktuelle Zeile (des Cursors, Endpos bei Bereich)
  ActXStart.w                   ; Word    => X-Position der aktuellen Zelle (bei Bereich Startpos)
  ActYStart.w                   ; Word    => Y-Position der aktuellen Zelle (bei Bereich Startpos)
  ActXEnd.w                     ; Word    => X-Position der aktuellen Zelle (bei Bereich Endpos)
  ActYEnd.w                     ; Word    => Y-Position der aktuellen Zelle (bei Bereich Endpos)
  LastVisCol.b                  ; Byte    => Letzte angezeigte Spalte
  LastVisRow.b                  ; Byte    => Letzte angezeigte Zeile
  Cells.l                       ; Long    => Anzahl der Zellen 
  Font.l                        ; Long    => Handle fr Schriftart
  GridVisible.b                 ; Byte    => Anzeige des Gitters (1=angezeigt, -1=unsichtbar)
  ColCaptVisible.b              ; Byte    => Anzeige der Spaltenberschrift (1=angezeigt, -1=unsichtbar)
  RowCaptVisible.b              ; Byte    => Anzeige der Zeilenberschrift (1=angezeigt, -1=unsichtbar)
  RowCaptWidth.b                ; Byte    => Spaltenbreite der Zeilenberschrift
  ColCustWidth.b                ; Byte    => Benutzerspezifische Spaltenbreiten-Anpassung (1=kann verndert werden, -1=fix)
  Color_Backgr.l                ; Long    => Hintergrundfarbe des Bereiches hinter den Zellen
  Color_Grid.l                  ; Long    => Farbe des Gitters
  Color_CellBack.l              ; Long    => Hintergrundfarbe in der Zelle
  Color_CellFore.l              ; Long    => Vordergrundfarbe in der Zelle
  Color_CaptBack.l              ; Long    => Hintergrundfarbe fr die berschrift/Beschriftung
  Color_CellFocus.l             ; Long    => Hintergrundfarbe der Zelle, bei Fokus-Erhalt
  Color_CaptFocus.l             ; Long    => Hintergrundfarbe der berschrift/Beschriftung, bei Fokus-Erhalt einer enthaltenen Zelle
  Color_CellLock.l              ; Long    => Hintergrundfarbe der Zelle, wenn Zelle gesperrt ist
  Color_CellLoFoc.l             ; Long    => Hintergrundfarbe der Zelle, bei Fokus-Erhalt mit dem Sperr-Zustand -1
  Color_CellFocusInact.l        ; Long    => Hintergrundfarbe der aktuellen Zelle, wenn Grid nicht fokusiert ist
  InputMode.b                   ; Byte    => Eingabemodus 0=keine Eingabe, 1=Text, 16=Rollup 
  AutoRedraw.b                  ; Byte    => Automatische Darstellungsaktualisierung aktivieren (1=auto, -1=manual)
  CellMatrixStartID.l           ; Long    => Start-Nummer in der Liste der Zellen-Info, mit der die Zellen des jeweiligen Grids beginnen (+Zellenanzahl=End-Pos)
  ShowColSummary.b              ; Byte    => Anzeigen der Spalten-Summe
  AutoSort.b                    ; Byte    => Automatische Sortierung, wenn Sortierung vorgegeben bei neuer Zeile oder Inhaltsnderung in Sortierspalte
  SortCol.b                     ; Byte    => Spalte nach der aktuell sortiert wurde
  SortDir.b                     ; Byte    => Sortier-Richtung mit der aktuell sortiert wurde
  UserSort.b                    ; Byte    => Benutzerspezifische Sortierung (1=kann mit Doppelklick sortiert werden, -1=fix)
  GridLock.b                    ; Byte    => Sperrzustand der gesamten Tabelle, -1=nicht editierbar,-16=nicht auswhlbar, 1 und 16 ist das gleiche, nur nicht grau hinterlegte Zellen
  ScrollBarHVis.b               ; Byte    => Sichtbarkeit des horizontalen Scrollbalken, -1=nicht sichtbar, 1=sichtbar
  ScrollBarVVis.b               ; Byte    => Sichtbarkeit des vertikalen Scrollbalken, -1=nicht sichtbar, 1=sichtbar
  RowExpand.b                   ; Byte    => Zeilen-Details zulassen, -1=nicht zugelassen, 1=zugelassen
  CommaSep.b                    ; Byte    => ASCII-Code fr Komma-Separator
  ParentGrid.l                  ; Long    => Handle fr ParentGrid (ist nur gefllt, wenn als Subgrid aktiv)
  Hidden.b                      ; Byte    => Gadget ist sichtbar/versteckt (1=Hidden, -1=Visible)
EndStructure


Structure CSGrid_TypeCell
  content.s                     ; String  => Inhalt der Zelle
  lock.b                        ; Byte    => Sperr-Status der Zelle, -1=nicht editierbar,-16=nicht auswhlbar,0=Standard
  ;color_back.l                  ; Long    => Hintergrundfarbe der Zelle
EndStructure


Structure CSGrid_TypeCol
  hGadget.l                     ; Long    => Handle des Grids
  col.b                         ; Byte    => Nummer der Spalte
  width.w                       ; Word    => Breite der Spalte
  caption.s                     ; String  => Spaltenbeschriftung
  captorient.b                  ; Byte    => Ausrichtung der Spaltenbeschriftung (0=links, 1=rechts, 2=zentriert)
  datatype.b                    ; Byte    => Datentyp der Zellen der Spalte, 0=Text, 1=Ganzzahl, 2=Boolean, 3=Date/Time, 4=Picture, 16=Fliekomma, 17=Fliekomma (2 Stellen), 32=EUR, 33=USD, 64=Prozent, 127=benutzerdefiniertes Ausgabeformat
  userNumberFormat.s            ; String  => Benutzerdefiniertes Zahlenausgabeformat
  summary.b                     ; Byte    => Spaltensumme wird erzeugt
  sumval.f                      ; Float   => Wert der Spaltensumme
  inputType.b                   ; Byte    => Eingabetyp
                                ;            0=freie Texteingabe
                                ;            16=Spin
                                ;            17=Datepicker
                                ;            18=IPAddress
                                ;            19=Trackbar
                                ;            32=Rollup mit Wertliste, 33=Rollup mit Wertliste 2-spaltig, 
                                ;            34=Combo mit Werteliste
                                ;            64=Rollup mit SQL-String, 65=Rollup mit SQL-String 2-spaltig (Boolean-Datentyp setzt Eingabeformat automatisch)
  inputValueMin.l               ; Long    => Min-Wert bei Eingabe
  inputValueMax.l               ; Long    => Max-Wert bei Eingabe
  inputRessource.s              ; String  => Eingabe-Ressource (Eingabeformat, Werteliste, SQL-String) in Kombination mit inputType ausgewertet
  colorBack.l                   ; Long    => Hintergrundfarbe der kompletten Spalte
EndStructure


Structure CSGrid_TypeRow
  hGadget.l                     ; Long    => Handle des Grids
  row.w                         ; Word    => Nummer der Zeile
  height.w                      ; Word    => Hhe der Zeile
  caption.s                     ; String  => Zeilenbeschriftung
  hDetails.l                    ; Long    => Handle des Zeilen-Details-Objektes (kann auch ein CSGridGadget sein)
  DetailsHeight.w               ; Word    => Hhe des Zeilen-Details-Objektes
  DetailsVisible.b              ; Byte    => Status des Zeilen-Details (-1=nicht angezeigt, 1=angezeigt)
  DetailsIsGrid.b               ; Byte    => 1=Details ist ein CS-Grid-Objekt
  colorBack.l                   ; Long    => Hintergrundfarbe der kompletten Zeile
EndStructure


; **************************************************************
;- Global Variables / Globale Variablen
; **************************************************************

;Global VT.TB_GadgetVT          ; Struktur=> Enthlt die Struktur der Objekt-Referenzen


; **************************************************************
;- Declaration of Functions / Deklaration von Funktionen
; **************************************************************

; ffentliche Funktionen:
DeclareDLL CSGridGadget_Init()                                                            ; PUBLIC-Funktion zur Initialisierung der Grid-Gadget-Bibliothek
DeclareDLL CSGridGadget(Gadget.l,x.w,y.w,width.w,height.w,cols.b,rows.w)                  ; PUBLIC-Funktion fr das Erzeugen eines Grid-Gadgets
DeclareDLL.l CSGridGadget_GetActualGrid()                                                 ; PUBLIC-Funktion zum Ermitteln des aktuellen Grids
DeclareDLL CSGridGadget_SetAutoRedraw(Gadget.l,Enabled.b)                                 ; PUBLIC-Funktion zum Setzen der autom. Zeichnung bei nderung
DeclareDLL.b CSGridGadget_GetAutoRedraw(Gadget.l)                                         ; PUBLIC-Funktion zum Ermitteln der autom. Zeichnung bei nderung
DeclareDLL CSGridGadget_SetAutoSort(Gadget.l,Enabled.b)                                   ; PUBLIC-Funktion zur Aktivierung der automatischen Sortierung
DeclareDLL.b CSGridGadget_GetAutoSort(Gadget.l)                                           ; PUBLIC-Funktion zum Ermitteln der Aktivierung der automatischen Sortierung
DeclareDLL CSGridGadget_SetGridLockStatus(Gadget.l,Status.b)                              ; PUBLIC-Funktion zum Setzen des Sperr-Status der gesamten Tabelle
DeclareDLL.b CSGridGadget_GetGridLockStatus(Gadget.l)                                     ; PUBLIC-Funktion zum Ermitteln des Sperr-Status der gesamten Tabelle
DeclareDLL CSGridGadget_SetColDataType(Gadget.l,Col.b,DataType.b)                         ; PUBLIC-Funktion zum Setzen des Datentyps einer Spalte
DeclareDLL.b CSGridGadget_GetColDataType(Gadget.l,Col.b)                                  ; PUBLIC-Funktion zum Ermitteln des Datentyps einer Spalte
DeclareDLL CSGridGadget_SetColUserNumberFormat(Gadget.l,Col.b,UserNumberFormat.s)         ; PUBLIC-Funktion zum Setzen des Zahlen-Ausgabeformates fr eine Spalte
DeclareDLL.s CSGridGadget_GetColUserNumberFormat(Gadget.l,Col.b)                          ; PUBLIC-Funktion zum Ermitteln des Zahlen-Ausgabeformates einer Spalte
DeclareDLL CSGridGadget_SetColSummary(Gadget.l,Col.b,Enabled.b)                           ; PUBLIC-Funktion zum Setzen der Spalten-Summen-Eigenschaft
DeclareDLL.b CSGridGadget_GetColSummary(Gadget.l,Col.b)                                   ; PUBLIC-Funktion zum Ermitteln der Spalten-Summen-Eigenschaft
DeclareDLL.f CSGridGadget_GetColSummaryValue(Gadget.l,Col.b)                              ; PUBLIC-Funktion zum Ermitteln der Spalten-Summe (sofern Summierung aktiviert wurde)
DeclareDLL CSGridGadget_SetColInputType(Gadget.l,Col.b,InputType.b)                       ; PUBLIC-Funktion zum Setzen eines Eingabe-Typs
DeclareDLL.b CSGridGadget_GetColInputType(Gadget.l,Col.b)                                 ; PUBLIC-Funktion zum Ermitteln einer Eingabe-Ressource
DeclareDLL CSGridGadget_SetColInputRessource(Gadget.l,Col.b,Ressource.s)                  ; PUBLIC-Funktion zum Setzen einer Eingabe-Ressource
DeclareDLL.s CSGridGadget_GetColInputRessource(Gadget.l,Col.b)                            ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftung
DeclareDLL CSGridGadget_SetColInputMinMax(Gadget.l,Col.b,Min.l,Max.l)                     ; PUBLIC-Funktion zum Setzen eines Eingabe-Min/Max-Wertes
DeclareDLL CSGridGadget_SetColWidth(Gadget.l,Col.b,Width.w)                               ; PUBLIC-Funktion zum Setzen einer Spaltenbreite
DeclareDLL.w CSGridGadget_GetColWidth(Gadget.l,Col.b)                                     ; PUBLIC-Funktion zum Ermitteln der Spaltenbreite
DeclareDLL CSGridGadget_SetColCaption(Gadget.l,Col.b,Caption.s)                           ; PUBLIC-Funktion zum Setzen einer Spaltenbeschriftung
DeclareDLL.s CSGridGadget_GetColCaption(Gadget.l,Col.b)                                   ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftung
DeclareDLL CSGridGadget_SetColCaptionOrientation(Gadget.l,Col.b,Orientation.b)            ; PUBLIC-Funktion zum Setzen einer Spaltenbeschriftungs-Textausrichtung
DeclareDLL.b CSGridGadget_GetColCaptionOrientation(Gadget.l,Col.b)                        ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftungs-Ausrichtung
DeclareDLL CSGridGadget_SetColColorBack(Gadget.l,Col.b,Color.l)                           ; PUBLIC-Funktion zum Setzen einer Spalten-Hintergrundfarbe
DeclareDLL.l CSGridGadget_GetColColorBack(Gadget.l,Col.b)                                 ; PUBLIC-Funktion zum Ermitteln einer Spalten-Hintergrundfarbe
DeclareDLL CSGridGadget_SetRowCaption(Gadget.l,Row.w,Caption.s)                           ; PUBLIC-Funktion zum Setzen einer Zeilenbeschriftung
DeclareDLL.s CSGridGadget_GetRowCaption(Gadget.l,Row.w)                                   ; PUBLIC-Funktion zum Ermitteln einer Zeilenbeschriftung
DeclareDLL CSGridGadget_SetRowCaptionWidth(Gadget.l,Width.b)                              ; PUBLIC-Funktion zum Setzen der Zeilen-Beschriftungs-Breite
DeclareDLL.b CSGridGadget_GetRowCaptionWidth(Gadget.l)                                    ; PUBLIC-Funktion zum Ermitteln der Zeilen-Beschriftungs-Breite
DeclareDLL CSGridGadget_SetRowsHeight(Gadget.l,Height.b)                                  ; PUBLIC-Funktion zum Setzen der allgemeinen Zellen/Zeilen-Hhe
DeclareDLL.b CSGridGadget_GetRowsHeight(Gadget.l)                                         ; PUBLIC-Funktion zum Ermitteln der allgemeinen Zellen/Zeilen-Hhe
DeclareDLL CSGridGadget_SetRowHeight(Gadget.l,Row.w,Height.b)                             ; PUBLIC-Funktion zum Setzen einer Zeilenhhe einer speziellen Zeile
DeclareDLL.b CSGridGadget_GetRowHeight(Gadget.l,Row.w)                                    ; PUBLIC-Funktion zum Ermitteln der Zellen/Zeilen-Hhe einer speziellen Zeile
DeclareDLL CSGridGadget_SetRowDetailsEnabled(Gadget.l,Enabled.b)                          ; PUBLIC-Funktion zum Setzen der Spalten-Summen-Eigenschaft
DeclareDLL.b CSGridGadget_GetRowDetailsEnabled(Gadget.l)                                  ; PUBLIC-Funktion zum Ermitteln der Spalten-Summen-Eigenschaft
DeclareDLL CSGridGadget_SetRowDetailsHandle(Gadget.l,Row.w,handle.l,height.w,isGrid.b=-1) ; PUBLIC-Funktion zum Setzen eines Zeilen-Details-Objektes
DeclareDLL.l CSGridGadget_GetRowDetailsHandle(Gadget.l,Row.w)                             ; PUBLIC-Funktion zum Ermitteln einer Zeilenbeschriftung
DeclareDLL CSGridGadget_SetRowColorBack(Gadget.l,Row.w,Color.l)                           ; PUBLIC-Funktion zum Setzen eines Zeilen-Hintergrundfarbe
DeclareDLL.l CSGridGadget_GetRowColorBack(Gadget.l,Row.w)                                 ; PUBLIC-Funktion zum Ermitteln einer Zeilen-Hintergrundfarbe
DeclareDLL CSGridGadget_SetCellValue(Gadget.l,Col.b,Row.w,Value.s)                        ; PUBLIC-Funktion zum Setzen des Zell-Inhalts
DeclareDLL.s CSGridGadget_GetCellValue(Gadget.l,Col.b,Row.w)                              ; PUBLIC-Funktion zum Ermitteln eines Zellen-Inhalts
DeclareDLL CSGridGadget_SetCellLockStatus(Gadget.l,Col.b,Row.w,Status.b)                  ; PUBLIC-Funktion zum Setzen des Sperr-Zustandes einer Zelle
DeclareDLL.b CSGridGadget_GetCellLockStatus(Gadget.l,Col.b,Row.w)                         ; PUBLIC-Funktion zum Ermitteln des Sperr-Zustandes einer Zelle
DeclareDLL CSGridGadget_SetGridLinesVisibility(Gadget.l,Visible.b)                        ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Gitternetzlinien
DeclareDLL.b CSGridGadget_GetGridLinesVisibility(Gadget.l)                                ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Gitternetzlinien
DeclareDLL CSGridGadget_SetColCaptionVisibility(Gadget.l,Visible.b)                       ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Spaltenkpfen
DeclareDLL.b CSGridGadget_GetColCaptionVisibility(Gadget.l)                               ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Spaltenkpfen
DeclareDLL CSGridGadget_SetRowCaptionVisibility(Gadget.l,Visible.b)                       ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Zeilenkpfen
DeclareDLL.b CSGridGadget_GetRowCaptionVisibility(Gadget.l)                               ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Zeilenkpfen
DeclareDLL CSGridGadget_SetColsScaleable(Gadget.l,Enabled.b)                              ; PUBLIC-Funktion zum Setzen der Abnderbarkeit von Spaltenbreiten
DeclareDLL.b CSGridGadget_GetColsScaleable(Gadget.l)                                      ; PUBLIC-Funktion zum Ermitteln der Abnderbarkeit von Spaltenbreiten
DeclareDLL CSGridGadget_SetColsUserSort(Gadget.l,Enabled.b)                               ; PUBLIC-Funktion zum Setzen der Abnderbarkeit von Spaltensortierungen
DeclareDLL.b CSGridGadget_GetColsUserSort(Gadget.l)                                       ; PUBLIC-Funktion zum Ermitteln der Abnderbarkeit von Spaltensortierungen
DeclareDLL CSGridGadget_SetColorBackground(Gadget.l,Color.l)                              ; PUBLIC-Funktion zum Setzen der Hintergrundfarbe
DeclareDLL.l CSGridGadget_GetColorBackground(Gadget.l)                                    ; PUBLIC-Funktion zum Ermitteln der Hintergrundfarbe
DeclareDLL CSGridGadget_SetColorGrid(Gadget.l,Color.l)                                    ; PUBLIC-Funktion zum Setzen der Farbe der Gitternetzlinien
DeclareDLL.l CSGridGadget_GetColorGrid(Gadget.l)                                          ; PUBLIC-Funktion zum Ermitteln der Farbe der Gitternetzlinien
DeclareDLL CSGridGadget_SetColorCellBackDef(Gadget.l,Color.l)                             ; PUBLIC-Funktion zum Setzen der Standard Hintergrundfarbe der Zellen
DeclareDLL.l CSGridGadget_GetColorCellBackDef(Gadget.l)                                   ; PUBLIC-Funktion zum Ermitteln der Standard Hintergrundfarbe der Zellen
DeclareDLL CSGridGadget_SetColorCellTextDef(Gadget.l,Color.l)                             ; PUBLIC-Funktion zum Setzen der Standard Schrift-Farbe der Zellen
DeclareDLL.l CSGridGadget_GetColorCellTextDef(Gadget.l)                                   ; PUBLIC-Funktion zum Ermitteln der Standard Schrift-Farbe der Zellen
DeclareDLL CSGridGadget_SetColorColRowCapt(Gadget.l,Color.l)                              ; PUBLIC-Funktion zum Setzen der Farbe fr die Spalten-/Zeilen-berschriften
DeclareDLL.l CSGridGadget_GetColorColRowCapt(Gadget.l)                                    ; PUBLIC-Funktion zum Ermitteln der Farbe fr die Spalten-/Zeilen-berschriften
DeclareDLL CSGridGadget_SetColorCellBackFocus(Gadget.l,Color.l)                           ; PUBLIC-Funktion zum Setzen der Farbe fr fokusierte Zellen
DeclareDLL.l CSGridGadget_GetColorCellBackFocus(Gadget.l)                                 ; PUBLIC-Funktion zum Ermitteln der Farbe fr fokusierte Zellen
DeclareDLL CSGridGadget_SetColorColRowCaptFocus(Gadget.l,Color.l)                         ; PUBLIC-Funktion zum Setzen der Farbe fr Spalten-/Zeilen-berschriften von fokusierte Zellen
DeclareDLL.l CSGridGadget_GetColorColRowCaptFocus(Gadget.l)                               ; PUBLIC-Funktion zum Ermitteln der Farbe fr Spalten-/Zeilen-berschriften von fokusierte Zellen
DeclareDLL CSGridGadget_SetColorCellBackLock(Gadget.l,Color.l)                            ; PUBLIC-Funktion zum Setzen der Farbe fr eine gesperrte Zelle
DeclareDLL.l CSGridGadget_GetColorCellBackLock(Gadget.l)                                  ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine gesperrte Zelle
DeclareDLL CSGridGadget_SetColorCellBackLockFocus(Gadget.l,Color.l)                       ; PUBLIC-Funktion zum Setzen der Farbe fr eine gesperrte, fokusierte Zelle
DeclareDLL.l CSGridGadget_GetColorCellBackLockFocus(Gadget.l)                             ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine gesperrte, fokusierte Zelle
DeclareDLL CSGridGadget_SetColorCellBackFocusInactive(Gadget.l,Color.l)                   ; PUBLIC-Funktion zum Setzen der Farbe fr eine fokusierte Zelle eines inaktiven Gadgets
DeclareDLL.l CSGridGadget_GetColorCellBackFocusInactive(Gadget.l)                         ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine fokusierte Zelle eines inaktiven Gadgets
DeclareDLL CSGridGadget_SetFormatComma(Gadget.l,Char.s)                                   ; PUBLIC-Funktion zum Definieren des Komma-Zeichens fr die formatierte Zahlenausgabe
DeclareDLL.s CSGridGadget_GetFormatComma(Gadget.l)                                        ; PUBLIC-Funktion zum Ermitteln des Komma-Zeichens fr die formatierte Zahlenausgabe
DeclareDLL.w CSGridGadget_GetRowsCount(Gadget.l)                                          ; PUBLIC-Funktion zum Ermitteln der Zeilenanzahl
DeclareDLL.b CSGridGadget_GetColsCount(Gadget.l)                                          ; PUBLIC-Funktion zum Ermitteln der Spaltenanzahl
DeclareDLL CSGridGadget_SetActualCellValue(Gadget.l,Value.s)                              ; PUBLIC-Funktion zum Setzen des Inhaltes der aktuellen Zelle
DeclareDLL.s CSGridGadget_GetActualCellValue(Gadget.l)                                    ; PUBLIC-Funktion zum Ermitteln des Inhaltes der aktuellen Zelle
DeclareDLL CSGridGadget_SetActualCellState(Gadget.l,State.b)                              ; PUBLIC-Funktion zum Setzen des Status der aktuellen Zelle
DeclareDLL.b CSGridGadget_GetActualCellState(Gadget.l)                                    ; PUBLIC-Funktion zum Ermitteln des Status der aktuellen Zelle
DeclareDLL CSGridGadget_SetFont(Gadget.l,Font.l)                                          ; PUBLIC-Funktion zum Setzen der Schriftart
DeclareDLL.l CSGridGadget_GetFont(Gadget.l)                                               ; PUBLIC-Funktion zum Ermitteln der Schriftart
DeclareDLL.w CSGridGadget_GetActualRow(Gadget.l)                                          ; PUBLIC-Funktion zum Ermitteln der aktuellen Zeilen-Position des Cursors
DeclareDLL.b CSGridGadget_GetActualCol(Gadget.l)                                          ; PUBLIC-Funktion zum Ermitteln der aktuellen Spalten-Position des Cursors
DeclareDLL CSGridGadget_SetCursor(Gadget.l,Col.b,Row.w)                                   ; PUBLIC-Funktion zum Setzen des Cursors
DeclareDLL CSGridGadget_SetCursorRange(Gadget.l,StartCol.b,StartRow.w,EndCol.b,EndRow.w)  ; PUBLIC-Funktion zum Setzen eines Markierungsbereichs
DeclareDLL CSGridGadget_CopySelectionToClipboard(Gadget.l)                                ; PUBLIC-Funktion zum Kopieren der aktuellen Markierung in die Zwischenablage
DeclareDLL CSGridGadget_AddRow(Gadget.l,Position.w)                                       ; PUBLIC-Funktion zum Hinzufgen einer Zeile zu einem CS-Grid-Gadget
DeclareDLL CSGridGadget_AddRowWithContent(Gadget.l,Position.w,Text$,ImageID.l)            ; PUBLIC-Funktion zum Hinzufgen einer Zeile mit Inhalt (Spalten mit Tab [ASC10] getrennt) zu einem CS-Grid-Gadget
DeclareDLL CSGridGadget_RemoveRow(Gadget.l,Position.w)                                    ; PUBLIC-Funktion zum Enternen einer Zeile
DeclareDLL CSGridGadget_AddCol(Gadget.l,Position.b)                                       ; PUBLIC-Funktion zum Hinzufgen einer Spalte zu einem CS-Grid-Gadget
DeclareDLL CSGridGadget_AddColWithContent(Gadget.l,Position.b,Content.s,ImageID.l)        ; PUBLIC-Funktion zum Hinzufgen einer Spalte mit Inhalt (Spalten mit Tab [ASC10] getrennt) zu einem CS-Grid-Gadget
DeclareDLL CSGridGadget_RemoveCol(Gadget.l,Position.b)                                    ; PUBLIC-Funktion zum Entfernen einer Spalte 
DeclareDLL CSGridGadget_RemoveAllCells(Gadget.l)                                          ; PUBLIC-Funktion zum Entfernen smtlicher Zeilen
DeclareDLL CSGridGadget_ColSort(Gadget.l,Col.b,Direction.b)                               ; PUBLIC-Funktion zum Sortieren einer Tabelle nach einer bestimmten Spalte
DeclareDLL.b CSGridGadget_EventHandling(eventID.l,menueventID.l)                          ; PUBLIC-Funktion zum Verarbeiten eines Purebasic-Events
DeclareDLL.b CSGridGadget_EventExecute(Gadget.l,CSEvent.b)                                ; PUBLIC-Funktion zum Ausfhren eines Events in einem CS-Grid-Gadget
DeclareDLL CSGridGadget_SetFocus(Gadget.l,NoRedraw.b=-1)                                  ; PUBLIC-Funktion zum Setzen des Fokus eines CS-Grid-Gadgets
DeclareDLL CSGridGadget_Resize(Gadget.l,x.w,y.w,width.w,height.w,NoRedraw.b=-1)           ; PUBLIC-Funktion zum Positionieren und Skalieren eines CS-Grid-Objektes
DeclareDLL CSGridGadget_Redraw(Gadget.l)                                                  ; PUBLIC-Funktion zum manuellen Neuzeichnen eines Grid-Objektes
DeclareDLL CSGridGadget_SetAbsPosition(Gadget.l,x.w,y.w)                                  ; PUBLIC-Funktion zum manuellen Definieren der absoluten Position des CS-Grid-Objektes zum Fenster (wenn Element eines Parent-Objektes)
DeclareDLL CSGridGadget_FreeGadget(Gadget.l)                                              ; PUBLIC-Funktion zum Entfernen eines CS-Grid-Objektes


; Hilfsfunktionen:
Declare.b H_GetGadget(Gadget.l)                                                           ; Hilfsfunktion zum Ermitteln des aktuellen Gadget-Info-Sets
Declare.b H_CheckIfColSetExists(Col.b)                                                    ; Hilfsfunktion die ermittelt, ob fr eine Spalte ein Informations-Set angelegt wurde (1=JA, -1=Nein)
Declare.b H_CheckIfRowSetExists(Row.w)                                                    ; Hilfsfunktion die ermittelt, ob fr eine Zeile ein Informations-Set angelegt wurde (1=JA, -1=Nein)
Declare.b H_GetColDataType(Col.b)                                                         ; Hilfsfunktion zum Ermitteln des Datentyps einer Zelle
Declare.s H_GetColUserNumberFormat(Col.b)                                                 ; Hilfsfunktion zum Ermitteln des benutzerdefinierten Zahlenformats
Declare.b H_GetColSummaryFlag(Col.b)                                                      ; Hilfsfunktion zum Ermitteln der Spalten-Summen-Eigenschaft
Declare.w H_GetColWidth(Col.b)                                                            ; Hilfsfunktion zum Ermitteln der Spaltenbreite
Declare.b H_GetColHidden(Col.b)                                                           ; Hilfsfunktion zum Ermitteln der Spalten-Ausblendung
Declare.b H_GetColInputType(Col.b)                                                        ; Hilfsfunktion zum Ermitteln des Eingabe-Types
Declare.s H_GetColInputRessource(Col.b)                                                   ; Hilfsfunktion zum Ermitteln der Eingabe-Ressource
Declare.s H_GetColCaption(Col.b)                                                          ; Hilfsfunktion zum Ermitteln der Spaltenbeschriftung
Declare.b H_GetColCaptOrient(Col.b)                                                       ; Hilfsfunktion zum Ermitteln der Spaltenbeschriftungs-Ausrichtung
Declare.l H_GetColColorBack(Col.b)                                                        ; Hilfsfunktion zum Ermitteln der Spalten-Hintergrundfarbe
Declare.s H_GetRowCaption(Row.w)                                                          ; Hilfsfunktion zum Ermitteln der Zeilenbeschriftung
Declare.b H_GetRowHeight(Row.w)                                                           ; Hilfsfunktion zum Ermitteln der Zeilenhhe
Declare.l H_GetRowDetailsHandle(Row.w)                                                    ; Hilfsfunktion zum Ermitteln des Objektes fr die Zeilen-Details-Darstellung
Declare.l H_GetRowColorBack(Row.w)                                                        ; Hilfsfunktion zum Ermitteln der Hintergrundfarbe der Zeile
Declare.s H_GetCellValue(Col.b,Row.w)                                                     ; Hilfsfunktion zum Ermitteln des Zell-Inhalts
Declare.b H_GetCellLockStatus(Col.b,Row.w)                                                ; Hilfsfunktion zum Ermitteln des Sperr-Zustandes einer Zelle
Declare.b H_GetFocusedGrid()                                                              ; Hilfsfunktion zum Ermitteln des fokusierten Grids
Declare.l H_GetCell(Col.b,Row.w)                                                          ; Hilfsfunktion zum Indizieren einer Zelle im Infoset
Declare.s H_FormatNumberString(Format.s,Number.f)                                         ; Hilfsfunktion zum Formatieren einer Zahl
Declare.f H_CalcColSummary(Col.b)                                                         ; Hilfsfunktion zum Kalkulieren der Spaltensumme
Declare.b H_SortColbyMouse()                                                              ; Hilfsfunktion zum Sortieren einer Spalte mittels Maus, sofern zugelassen
Declare H_DrawGrid(ManualRedraw.b)                                                        ; Hilfsfunktion zum Zeichnen des Grids
Declare H_Scroll(Value.w,Vertical.b)                                                      ; Hilfsfunktion zum Scrollen der Tabelle
Declare H_DrawScrollbars(ReScale.b)                                                       ; Hilfsfunktion zum Zeichnen der Scrollbalken
Declare H_HideScrollbars(hTarget.b,vTarget.b,Must.b)                                      ; Hilfsfunktion zum Anzeigen/Ausblenden der Scrollbalken
Declare H_GetLastVisColRow()                                                              ; Hilfsfunktion zum Ermitteln der letzten, sichtbaren Spalte und Zeile
Declare H_MoveCursor(tMode.b,HDir.b,VDir.b)                                               ; Hilfsfunktion zum Bewegen des Cursor
Declare.b H_MoveCursorbyMouse(tMode.b,mPosX.w,mPosY.w)                                    ; Hilfsfunktion zum Setzen des Cursors auf Basis der Mausposition
Declare H_SetCursor(tMode.b,tCol.b,tRow.w)                                                ; Hilfsfunktion zum Setzen des aktuellen Cursors (-1=ganze Spalte/Zeile)
Declare.b H_CellInput(tMode.b)                                                            ; Hilfsfunktion um das Eingabefeld bei der Zell-Eingabe anzuzeigen
Declare H_InitShortCuts()                                                                 ; Hilfsfunktion zum Setzen der Tastatur-Shortcuts zur Steuerung des Grid-Controls
Declare H_RemoveShortCuts(tMode.b)                                                        ; Hilfsfunktion zum Entfernen der Tastatur-Shortcuts zur Steuerung des Grid-Controls
Declare H_SetCellValue(Col.b,Row.w,Value.s)                                               ; Hilfsfunktion zum Setzen des Zell-Inhalts
Declare H_GetCol(Gadget.l,Col.b)                                                          ; Hilfsfunktion zum Auswhlen der Spalte-Informationen, wenn nicht vorhanden wird diese angelegt
Declare H_SetColWidth(Gadget.l,Col.b,Width.w)                                             ; Hilfsfunktion zum Setzen der Spaltenbreite
Declare H_SetColHidden(Col.b,Hidden.b)                                                    ; Hilfsfunktion zum Setzen der Spalten-Ausblendung
Declare H_SetColDataType(Gadget.l,Col.b,DataType.b)                                       ; Hilfsfunktion zum Setzen des Datentyps einer Spalte
Declare H_SetColUserNumberFormat(Gadget.l,Col.b,userNumberFormat.s)                       ; Hilfsfunktion zum Setzen des benutzerdefinierten Zahlenformats
Declare H_SetColSummaryFlag(Gadget.l,Col.b,Summary.b)                                     ; Hilfsfunktion zum Setzen der Spalten-Summen-Eigenschaft
Declare H_DrawSummary(ActX.w,ActY.w,ActWidth.w,Col.b)                                     ; Hilfsfunktion zum Zeichnen der Spalten-Summe
Declare H_DrawSortSymbol(ActX.w,ActY.w,ActWidth.w,Direction.b)                            ; Hilfsfunktion zum Zeichnen des Sortierungs-Piktogramms
Declare H_DrawDetailsSymbol(ActX.w,ActY.w,ActWidth.w,Status.b)                            ; Hilfsfunktion zum Zeichnen des Expand/Collapse-Symbols der Zeilen-Details
Declare H_DrawCellContent(tText.s,tx.w,ty.w,twidth.w,tType.b,tOrient.b=-1,theight.w=0)    ; Hilfsfunktion zum Zeichnen des Zellinhalts
Declare H_DrawBooleanValue(ActX.w,ActY.w,ActWidth.w,Value.b)                              ; Hilfsfunktion zum Zeichnen der Checkbox fr boolsche Werte
Declare H_PositionDetailsObject(ActX.w,ActY.w,theight.w,Status.b,hDetails.l)              ; Hilfsfunktion zum Zeichnen/Positionieren des Zeilen-Details-Objektes
Declare.s H_FormatCell(tText.s,tType.b)                                                   ; Hilfsfunktion zum Formatieren des Zell-Inhalts
Declare H_DoColSorting(Col.b,Dir.b)                                                       ; Hilfsfunktion zum Sortieren des Grids nach einer speziellen Spalte
Declare H_SwapRowContent(sRow.w,dRow.w)                                                   ; Hilfsfunktion zum Verschieben des Inhaltes einer kompletten Zeile in eine andere Zeile
Declare.b H_EnableDetailsObject(NoRedraw.b=-1)                                            ; Hilfsfunktion zum Aktivieren von Zeilen-Details
Declare.b H_DisableDetailsObject(NoRedraw.b=-1,FocusOnParent.b=-1)                        ; Hilfsfunktion zum Deaktivieren von Zeilen-Details (wenn Subobjekt Fokus hat)
Declare H_DisableAlleDetailObjects()                                                      ; Hilfsfunktion zum Schlieen/Deaktivieren smtlicher Sub-Gadgets in einem Grid (mit Fokus vom Parent Grid aus)
Declare H_DrawDetails(hide.b)                                                             ; Hilfsfunktion zum Schlieen smtlicher Details
Declare.b H_DoRound(value.s)                                                              ; Hilfsfunktion zum korreken Runden
Declare H_CreateSelListEntries(tRessource.s,tType.b,tActValue.s)                          ; Hilfsfunktion zum Erstellen der List-Eintrge fr die List-Selektion
Declare H_MouseInput(tEventType)                                                          ; Hilfsfunktion zum Ermitteln der Mausaktivitt bei der Eingabe
Declare.l H_GetCellColorBack(Col.b,Row.b)                                                 ; Hilfsfunktion zur Ermittlung der Zellen-Hintergrundfarbe


; *************************************************************
;- PUBLIC FUNCTIONS / ffentliche Funktionen
; *************************************************************


ProcedureDLL CSGridGadget_Init() ; Initialization of CS-Grid Library
  ; PUBLIC-Funktion zur Initialisierung der Grid-Gadget-Bibliothek
  Global NewList CSGrid.CSGrid_Type()
  Global NewList CSGrid_Cell.CSGrid_TypeCell()
  Global NewList CSGrid_Col.CSGrid_TypeCol()
  Global NewList CSGrid_Row.CSGrid_TypeRow()  
  Global CSGrid_ActGridhGadget.l    ; Long    => Handle des aktuellen, fokusierten Grid-Controls
  Global CSGrid_WindowID.l          ; Long    => Handle fr die Fenster-ID (Standard=0) - bentigt fr die Shortcuts
  ;Global CSGrid_EventID.l           ; Long    => Merker fr Event-ID
  ;Global CSGrid_DetailsFocusGadget.l; Long    => 1=Details irgendeines Grids geffnet, -1=Details aller Grids geschlossen
  Global WindowID.l  
  Global CSGrid_Font.l              ; Long    => Handle fr Schriftart
  ;CSGrid_Font.l = LoadFont(0, "Tahoma ", CSGrid_DefHeight.w/2)  
EndProcedure


ProcedureDLL CSGridGadget(Gadget.l,x.w,y.w,width.w,height.w,cols.b,rows.w) ; Creates a CS-Grid Gadget
  ; PUBLIC-Funktion fr das Erzeugen eines Grid-Gadgets
  Protected n.l
  H_InitShortCuts()
  ResetList(CSGrid())
  AddElement(CSGrid())
  ;Debug CountList(CSGrid())
  ;CSGrid()\Font = CSGrid_Font.l
  CSGrid()\DefGridWidth = #DefGridWidth                       ; Standard-Zellenbreite
  CSGrid()\DefGridHeight = #DefGridHeight                     ; Standard-Zellenhhe
  CSGrid()\Color_Grid = #DefColor_Grid                        ; Standardfarbe fr das Gitternetz
  CSGrid()\Color_Backgr = #DefColor_Backgr                    ; Standardfarbe fr den Hintergrund
  CSGrid()\Color_CellBack = #DefColor_CellBack                ; Standardfarbe fr den Zellenhintergrund
  CSGrid()\Color_CaptBack = #DefColor_CaptBack                ; Standardfarbe fr den berschrift/Beschriftungs-Hintergrund
  CSGrid()\Color_CaptFocus = #DefColor_CaptFocus              ; Standardfarbe fr den berschrift/Beschriftungs-Hintergrund, bei Fokus-Erhalt einer enthaltenen Zelle
  CSGrid()\Color_CellLoFoc = #DefColor_CellLoFoc              ; Standardfarbe fr den Zellhintergrund bei Fokus-Erhalt und Sperr-Zustand -1
  CSGrid()\Color_CellFore = #DefColor_CellFore                ; Standardfarbe fr den Zelleninhalt (Text)
  CSGrid()\Color_CellFocus = #DefColor_CellFocus              ; Standardfarbe fr den Zellenhintergrund bei Fokus-Erhalt
  CSGrid()\Color_CellLock = #DefColor_CellLock                ; Standardfarbe fr den Zellenhintergrund, wenn Zelle gesperrt ist
  CSGrid()\Color_CellFocusInact = #DefColor_CellFocusInact    ; Standardfarbe fr den Zellenhintergrund der aktiven Zelle, wenn Grid nicht fokusiert ist
  CSGrid()\GridVisible = #DefGridVisible                      ; Standardmig werden Gitternetz-Linien angezeigt
  CSGrid()\ColCaptVisible = #DefColCaptVisible                ; Standardmig werden Spaltenberschriften mit angezeigt
  CSGrid()\RowCaptVisible = #DefRowCaptVisible                ; Standardmig werden Zeilenberschriften mit angezeigt
  CSGrid()\RowCaptWidth = #DefColCaptWidth                    ; Standardmige Spaltenbreite fr die Zeilenberschrift    
  CSGrid()\AutoRedraw = 1
  CSGrid()\AutoSort = -1
  CSGrid()\SortCol = -1
  CSGrid()\UserSort = -1
  CSGrid()\SortDir = 1
  CSGrid()\Left = x.w
  CSGrid()\Top = y.w
  CSGrid()\Width = width.w
  CSGrid()\Height = height.w
  CSGrid()\LeftAbs = -1
  CSGrid()\TopAbs = -1
  CSGrid()\Cols = cols.b
  CSGrid()\Rows = rows.w
  CSGrid()\Cells = CSGrid()\Cols * CSGrid()\Rows
  CSGrid()\CellMatrixStartID = CountList(CSGrid_Cell())
  LastElement(CSGrid_Cell())
  For n = 1 To CSGrid()\Cells
    AddElement(CSGrid_Cell())
  Next
  CSGrid()\ImgWidth = CSGrid()\Width-#ScrollbarSize-3
  CSGrid()\ImgHeight = CSGrid()\Height-#ScrollbarSize-3
  CSGrid()\hImage = CreateImage(#PB_Any, CSGrid()\ImgWidth,CSGrid()\ImgHeight)
  CSGrid()\hGadget = ContainerGadget(Gadget,CSGrid()\Left,CSGrid()\Top,CSGrid()\Width,CSGrid()\Height,CSGrid()\hImage)
  If Gadget <> #PB_Any
    CSGrid()\hGadget = Gadget
  EndIf
    CSGrid()\hImageGadget = ImageGadget(#PB_Any,0,0,CSGrid()\ImgWidth,CSGrid()\ImgHeight,CSGrid()\hImage)
    CSGrid()\hVscrollGadget = ScrollBarGadget(#PB_Any,CSGrid()\Width-#ScrollbarSize-3,0,#ScrollbarSize,CSGrid()\Height-#ScrollbarSize,0,CSGrid()\Rows,1,#PB_ScrollBar_Vertical)
    CSGrid()\hHscrollGadget = ScrollBarGadget(#PB_Any,0,CSGrid()\Height-#ScrollbarSize-3,CSGrid()\Width-#ScrollbarSize,#ScrollbarSize,0,CSGrid()\Cols,1)
  CloseGadgetList()
  H_DrawGrid(-1)
  H_DrawScrollbars(1)  
  
;   VT\FreeGadget = @CSGridGadget_FreeGadget()
;   VT\GetGadgetState = @CSGridGadget_GetActualCellState()
;   VT\SetGadgetState = @CSGridGadget_SetActualCellState()
;   VT\GetGadgetText = @CSGridGadget_GetActualCellValue()
;   VT\SetGadgetText = @CSGridGadget_SetActualCellValue()
;   VT\AddGadgetItem = @CSGridGadget_AddRowWithContent()
;   VT\AddGadgetItem2 = @CSGridGadget_AddRowWithContent()
;   VT\RemoveGadgetItem = @CSGridGadget_RemoveRow()
;   VT\ClearGadgetItemList = @CSGridGadget_RemoveAllCells()
;   VT\ResizeGadget = @CSGridGadget_Resize()
;   VT\CountGadgetItems = @CSGridGadget_GetRowsCount()
  ;VT\GetGadgetItemState.l
  ;VT\SetGadgetItemState.l
  ;VT\GetGadgetItemText.l
  ;VT\SetGadgetItemText.l

;   TB_SetGadget(Gadget, CSGrid()\hGadget, @VT)  
  ProcedureReturn CSGrid()\hGadget
EndProcedure


ProcedureDLL.l CSGridGadget_GetActualGrid() ; Returns the Gadget-ID of the actual / focused CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des aktuellen Grids
  ProcedureReturn CSGrid_ActGridhGadget
EndProcedure


ProcedureDLL CSGridGadget_Redraw(Gadget.l) ; Redraws a CS-Grid-Gadget
  ; PUBLIC-Funktion zum manuellen Neuzeichnen eines Grid-Objektes
  If H_GetGadget(Gadget.l) = 1
    H_DrawGrid(1)
  EndIf
EndProcedure


ProcedureDLL.w CSGridGadget_GetActualRow(Gadget.l) ; Returns the ID of cursor's row position of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der aktuellen Zeilen-Position des Cursors
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\ActRowEnd
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetActualCol(Gadget.l) ; Returns the ID of cursor's col position of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der aktuellen Spalten-Position des Cursors
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\ActColEnd
  EndIf
EndProcedure


ProcedureDLL.w CSGridGadget_GetRowsCount(Gadget.l) ; Returns the count of Rows of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Zeilenanzahl
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Rows
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetColsCount(Gadget.l) ; Returns the count of Cols of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Spaltenanzahl
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Cols
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetActualCellValue(Gadget.l) ; Returns the content of the actual cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Inhaltes der aktuellen Zelle
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn H_GetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetActualCellValue(Gadget.l,Value.s) ; Sets the content of the actual cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Inhaltes der aktuellen Zelle
  If H_GetGadget(Gadget.l) = 1
    CSGridGadget_SetCellValue(Gadget.l,CSGrid()\ActColEnd,CSGrid()\ActRowEnd,Value.s)
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetActualCellState(Gadget.l) ; Returns the state of the actual cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Status der aktuellen Zelle
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn H_GetCellLockStatus(CSGrid()\ActColEnd,CSGrid()\ActRowEnd)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetActualCellState(Gadget.l,State.b) ; Sets the state of the actual cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Status der aktuellen Zelle
  If H_GetGadget(Gadget.l) = 1
    CSGridGadget_SetCellLockStatus(Gadget.l,CSGrid()\ActColEnd,CSGrid()\ActRowEnd,State.b)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColDataType(Gadget.l,Col.b,DataType.b) ; Sets the datatype for a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Datentyps einer Spalte
  ; Datentyp der Zellen der Spalte, 0=Text, 1=Ganzzahl, 2=Boolean, 16=Fliekomma, 17=Fliekomma (2 Stellen), 32=EUR, 33=USD, 64=Prozent, 127=benutzerdefiniertes Ausgabeformat
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      H_SetColDataType(Gadget.l,Col.b,DataType.b)
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetColDataType(Gadget.l,Col.b) ; Returns the datatype of a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Datentyps einer Spalte
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColDataType(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColUserNumberFormat(Gadget.l,Col.b,UserNumberFormat.s) ; Sets the user numberformat for a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Zahlen-Ausgabeformates fr eine Spalte
  ; Datentyp der Zellen der Spalte, 0=Text, 1=Ganzzahl, 2=Boolean, 16=Fliekomma, 17=Fliekomma (2 Stellen), 32=EUR, 33=USD, 64=Prozent, 127=benutzerdefiniertes Ausgabeformat
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      H_SetColUserNumberFormat(Gadget.l,Col.b,UserNumberFormat.s)
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetColUserNumberFormat(Gadget.l,Col.b) ; Returns the user numberformat string of a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Zahlen-Ausgabeformates einer Spalte
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColUserNumberFormat(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColSummary(Gadget.l,Col.b,Enabled.b) ; Sets the summary-flag for a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Spalten-Summen-Eigenschaft
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      H_SetColSummaryFlag(Gadget.l,Col.b,Enabled.b)
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetColSummary(Gadget.l,Col.b) ; Returns the value of the summary-flag of a column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Spalten-Summen-Eigenschaft
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColSummaryFlag(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.f CSGridGadget_GetColSummaryValue(Gadget.l,Col.b) ; Returns the value/sum of a summarized column of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Spalten-Summe (sofern Summierung aktiviert wurde)
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_GetColSummaryFlag(Col.b) = 1      
        ProcedureReturn CSGrid_Col()\sumval
      Else
        ProcedureReturn 0
      EndIf
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowDetailsEnabled(Gadget.l,Enabled.b) ; Enables showing row details (if available) of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Spalten-Summen-Eigenschaft
  If H_GetGadget(Gadget.l) = 1
    If CSGrid()\hGadget <> 0
      CSGrid()\RowExpand = Enabled.b
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetRowDetailsEnabled(Gadget.l) ; Returns the value of the row-details-flag of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Spalten-Summen-Eigenschaft
  If H_GetGadget(Gadget.l) = 1
    If CSGrid()\hGadget <> 0
      ProcedureReturn CSGrid()\RowExpand
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetGridLockStatus(Gadget.l,Status.b) ; Sets the lock-status of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Sperr-Status der gesamten Tabelle
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\GridLock = Status.b
    If Status.b <= -16 Or Status.b >= 16
      CSGrid()\ActColStart = -1 
      CSGrid()\ActRowStart = -1
      CSGrid()\ActColEnd = -1 
      CSGrid()\ActRowEnd = -1
    EndIf
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetGridLockStatus(Gadget.l) ; Returns the lock-status of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Sperr-Status der gesamten Tabelle
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\GridLock
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowsHeight(Gadget.l,Height.b) ; Sets the row/cell's height of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Zellen/Zeilen-Hhe
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\DefGridHeight = Height.b
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetRowsHeight(Gadget.l) ; Returns the row/cell's height of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Zellen/Zeilen-Hhe
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\DefGridHeight
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColWidth(Gadget.l,Col.b,Width.w) ; Sets a Column-Width of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Spaltenbreite
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      H_SetColWidth(Gadget.l,Col.b,Width.w)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.w CSGridGadget_GetColWidth(Gadget.l,Col.b) ; Returns a Column-Width of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Spaltenbreite
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColWidth(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColCaption(Gadget.l,Col.b,Caption.s) ; Sets a Column-Caption of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Spaltenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\caption = Caption.s
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetColCaption(Gadget.l,Col.b) ; Returns a Column-Caption of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColCaption(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColCaptionOrientation(Gadget.l,Col.b,Orientation.b) ; Sets a Column-Caption-Orientation of a CS-Grid-Gadget (0=left, 1=right, 2=center)
  ; PUBLIC-Funktion zum Setzen einer Spaltenbeschriftungs-Textausrichtung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\captorient = Orientation.b
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetColCaptionOrientation(Gadget.l,Col.b) ; Returns a Column-Caption-Orientation of a CS-Grid-Gadget (0=left, 1=right, 2=center)
  ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftungs-Ausrichtung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColCaptOrient(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColInputType(Gadget.l,Col.b,InputType.b) ; Sets a Column Input-Type of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen eines Eingabe-Typs
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\inputType = InputType.b
      ;H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetColInputType(Gadget.l,Col.b) ; Returns a Column Input-Type of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Spaltenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColInputType(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColInputRessource(Gadget.l,Col.b,Ressource.s) ; Sets a Column Input-Ressource of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Eingabe-Ressource
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\inputRessource = Ressource.s
      ;H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetColInputRessource(Gadget.l,Col.b) ; Returns a Column Input-Ressource of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Eingabe-Ressource
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColInputRessource(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColColorBack(Gadget.l,Col.b,Color.l) ; Sets a Column Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Spalten-Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\colorBack = Color.l
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColColorBack(Gadget.l,Col.b) ; Returns a Column Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Spalten-Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetColColorBack(Col.b)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColInputMinMax(Gadget.l,Col.b,Min.l,Max.l) ; Sets a Column Input-Min/Max-Value of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen eines Eingabe-Min/Max-Wertes
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfColSetExists(Col.b) < 1
        LastElement(CSGrid_Col())
        AddElement(CSGrid_Col())
        CSGrid_Col()\hGadget = Gadget.l
        CSGrid_Col()\col = Col.b
      EndIf
      CSGrid_Col()\inputValueMin = Min
      CSGrid_Col()\inputValueMax = Max
      ;H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_ColSort(Gadget.l,Col.b,Direction.b) ; Sorts a CS-Grid-Gadget according to a Column
  ; PUBLIC-Funktion zum Sortieren einer Tabelle nach einer bestimmten Spalte
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0 And (Direction.b = 1 Or Direction.b = -1)
      H_DoColSorting(Col.b,Direction.b)
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowCaption(Gadget.l,Row.w,Caption.s) ; Sets a Row-Caption of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Zeilenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfRowSetExists(Row.w) < 1
        LastElement(CSGrid_Row())
        AddElement(CSGrid_Row())
        CSGrid_Row()\hGadget = Gadget.l
        CSGrid_Row()\row = Row.w
      EndIf
      CSGrid_Row()\caption = Caption.s
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetRowCaption(Gadget.l,Row.w) ; Returns a Row-Caption of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Zeilenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetRowCaption(Row.w)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowCaptionWidth(Gadget.l,Width.b) ; Defines width of Row-Caption bar of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Zeilen-Beschriftungs-Breite
  If H_GetGadget(Gadget.l) = 1
    If CSGrid()\hGadget <> 0
      CSGrid()\RowCaptWidth = Width.b
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetRowCaptionWidth(Gadget.l) ; Returns the value of the width of the Row-Caption bar of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Zeilen-Beschriftungs-Breite
  If H_GetGadget(Gadget.l) = 1
    If CSGrid()\hGadget <> 0
      ProcedureReturn CSGrid()\RowCaptWidth
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowHeight(Gadget.l,Row.w,Height.b) ; Sets a Row-Height of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen einer Zeilenhhe
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfRowSetExists(Row.w) < 1
        LastElement(CSGrid_Row())
        AddElement(CSGrid_Row())
        CSGrid_Row()\hGadget = Gadget.l
        CSGrid_Row()\row = Row.w
      EndIf
      CSGrid_Row()\height = Height.b
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetRowHeight(Gadget.l,Row.w) ; Returns a Row-Height of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Zeilenhhe
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetRowHeight(Row.w)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowDetailsHandle(Gadget.l,Row.w,handle.l,height.w,isGrid.b=-1) ; Sets a Row-Details-Object-Handle of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen eines Zeilen-Details-Objektes
  If IsGadget(handle.l) Or handle.l = 0
    If H_GetGadget(Gadget.l) = 1
      If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
        If H_CheckIfRowSetExists(Row.w) < 1
          LastElement(CSGrid_Row())
          AddElement(CSGrid_Row())
          CSGrid_Row()\hGadget = Gadget.l
          CSGrid_Row()\row = Row.w
        EndIf
        CSGrid_Row()\hDetails = handle.l
        CSGrid_Row()\DetailsIsGrid = isGrid.b
        If handle.l > 0
          CSGrid_Row()\DetailsHeight = height.w
          HideGadget(handle,1)
          CSGrid_Row()\DetailsVisible = -1
          ;CSGrid_DetailsFocusGadget = 0
        Else
          CSGrid_Row()\DetailsHeight = 0
        EndIf
        H_DrawGrid(-1)
        If isGrid = 1
          If H_GetGadget(handle.l) = 1
            CSGrid()\Hidden = 1
          EndIf
        EndIf
      EndIf
    EndIf    
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetRowDetailsHandle(Gadget.l,Row.w) ; Returns a Row-Details-Object-Handle of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Zeilenbeschriftung
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetRowDetailsHandle(Row.w)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetRowColorBack(Gadget.l,Row.w,Color.l) ; Sets a Row-Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen eines Zeilen-Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      If H_CheckIfRowSetExists(Row.w) < 1
        LastElement(CSGrid_Row())
        AddElement(CSGrid_Row())
        CSGrid_Row()\hGadget = Gadget.l
        CSGrid_Row()\row = Row.w
      EndIf
      CSGrid_Row()\colorBack = Color.l
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetRowColorBack(Gadget.l,Row.w) ; Returns a Row-Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln einer Zeilen-Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    If Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetRowColorBack(Row.w)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetCellValue(Gadget.l,Col.b,Row.w,Value.s) ; Sets a Cell-Value of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Zell-Inhalts
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      H_SetCellValue(Col.b,Row.w,Value.s)
    EndIf
  EndIf
EndProcedure


ProcedureDLL.s CSGridGadget_GetCellValue(Gadget.l,Col.b,Row.w) ; Returns a Cell-Value of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln eines Zellen-Inhalts
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetCellValue(Col.b,Row.w)
    EndIf  
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetCellLockStatus(Gadget.l,Col.b,Row.w,Status.b) ; Sets the Lock-Status of a Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Sperr-Zustandes einer Zelle
  Protected tcell.l
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      tcell.l = (CSGrid()\Cols * Row.w) + Col.b + CSGrid()\CellMatrixStartID
      If tCell.l >= 0
        SelectElement(CSGrid_Cell(),tcell.l)
        CSGrid_Cell()\lock = Status.b
        H_DrawGrid(-1)
      EndIf
    EndIf
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetCellLockStatus(Gadget.l,Col.b,Row.w) ; Returns the Lock-Status of a Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Sperr-Zustandes einer Zelle
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn H_GetCellLockStatus(Col.b,Row.w)
    EndIf  
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorBackground(Gadget.l,Color.l) ; Sets the Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_Backgr = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorBackground(Gadget.l) ; Returns Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Hintergrundfarbe
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_Backgr 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorGrid(Gadget.l,Color.l) ; Sets the Gridlines-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe der Gitternetzlinien
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_Grid = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorGrid(Gadget.l) ; Returns Gridlines-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe der Gitternetzlinien
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_Grid 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellBackDef(Gadget.l,Color.l) ; Sets the Cell's default Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Standard Hintergrundfarbe der Zellen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellBack = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellBackDef(Gadget.l) ; Returns Cell's default Background-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Standard Hintergrundfarbe der Zellen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellBack 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellTextDef(Gadget.l,Color.l) ; Sets the Cell's default Text-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Standard Schrift-Farbe der Zellen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellFore = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellTextDef(Gadget.l) ; Returns Cell's default Text-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Standard Schrift-Farbe der Zellen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellFore 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorColRowCapt(Gadget.l,Color.l) ; Sets the Color of the Column/Row-Header of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr die Spalten-/Zeilen-berschriften
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CaptBack = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorColRowCapt(Gadget.l) ; Returns Cell's default Text-Color of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr die Spalten-/Zeilen-berschriften
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CaptBack 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellBackFocus(Gadget.l,Color.l) ; Sets the Color of a focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr fokusierte Zellen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellFocus = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellBackFocus(Gadget.l) ; Returns the Color of a focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr fokusierte Zellen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellFocus 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorColRowCaptFocus(Gadget.l,Color.l) ; Sets the Color of the Header of a focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr Spalten-/Zeilen-berschriften von fokusierte Zellen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CaptFocus = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorColRowCaptFocus(Gadget.l) ; Returns the Color of the Header of a focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr Spalten-/Zeilen-berschriften von fokusierte Zellen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CaptFocus 
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellBackLock(Gadget.l,Color.l) ; Sets the Color of a locked Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr eine gesperrte Zelle
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellLock = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellBackLock(Gadget.l) ; Returns the Color of a locked Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine gesperrte Zelle
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellLock
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellBackLockFocus(Gadget.l,Color.l) ; Sets the Color of a locked, focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr eine gesperrte, fokusierte Zelle
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellLoFoc = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellBackLockFocus(Gadget.l) ; Returns the Color of a locked, focused Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine gesperrte, fokusierte Zelle
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellLoFoc
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetColorCellBackFocusInactive(Gadget.l,Color.l) ; Sets the Color of a focused Cell of a inactive CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Farbe fr eine fokusierte Zelle eines inaktiven Gadgets
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Color_CellFocusInact = Color.l
    H_DrawGrid(-1)
  EndIf
EndProcedure


ProcedureDLL.l CSGridGadget_GetColorCellBackFocusInactive(Gadget.l) ; Returns the Color of a focused Cell of a inactive CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Farbe fr eine fokusierte Zelle eines inaktiven Gadgets
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Color_CellFocusInact
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetGridLinesVisibility(Gadget.l,Visible.b) ; Sets the flag for visibility of the Grid-Lines of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Gitternetzlinien
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\GridVisible = Visible.b
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetGridLinesVisibility(Gadget.l) ; Returns the flag for visibility of the Grid-Lines of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Gitternetzlinien
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\GridVisible
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetColCaptionVisibility(Gadget.l,Visible.b) ; Sets the flag for visibility of the Column-Headers of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Spaltenkpfen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\ColCaptVisible = Visible.b
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetColCaptionVisibility(Gadget.l) ; Returns the flag for visibility of the Column-Headers of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Spaltenkpfen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\ColCaptVisible
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetRowCaptionVisibility(Gadget.l,Visible.b) ; Sets the flag for visibility of the Row-Headers of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Sichtbarkeit von Zeilenkpfen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\RowCaptVisible = Visible.b
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetRowCaptionVisibility(Gadget.l) ; Returns the flag for visibility of the Row-Headers of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Sichtbarkeit von Zeilenkpfen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\RowCaptVisible
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetColsScaleable(Gadget.l,Enabled.b) ; Sets the flag for customizing width of Columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Abnderbarkeit von Spaltenbreiten
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\ColCustWidth = Enabled.b
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetColsScaleable(Gadget.l) ; Returns the flag for customizing width of Columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Abnderbarkeit von Spaltenbreiten
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\ColCustWidth
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetColsUserSort(Gadget.l,Enabled.b) ; Sets the flag for customizing sorting of Columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Abnderbarkeit von Spaltensortierungen
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\UserSort = Enabled.b
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetColsUserSort(Gadget.l) ; Returns the flag for customizing sorting of Columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Abnderbarkeit von Spaltensortierungen
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\UserSort
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetAutoSort(Gadget.l,Enabled.b) ; Sets a auto-sort flag for a CS-Grid-Gadget
  ; PUBLIC-Funktion zur Aktivierung der automatischen Sortierung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      CSGrid()\AutoSort = Enabled.b
    EndIf
  EndIf
EndProcedure


ProcedureDLL.b CSGridGadget_GetAutoSort(Gadget.l) ; Returns a the auto-sort flag of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Aktivierung der automatischen Sortierung
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And CSGrid()\hGadget <> 0
      ProcedureReturn CSGrid()\AutoSort
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetAutoRedraw(Gadget.l,Enabled.b) ; Sets the flag for auto-redraw of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der autom. Zeichnung bei nderung
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\AutoRedraw = Enabled.b
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_GetAutoRedraw(Gadget.l) ; Returns the flag for auto-redraw of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der autom. Zeichnung bei nderung
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\AutoRedraw
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetFont(Gadget.l,Font.l) ; Sets the font of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen der Schriftart
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Font = Font.l
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.l CSGridGadget_GetFont(Gadget.l) ; Returns the font of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln der Schriftart
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn CSGrid()\Font
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetFormatComma(Gadget.l,Char.s) ; Sets the comma-symbol for a formatted output of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Definieren des Komma-Zeichens fr die formatierte Zahlenausgabe
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\CommaSep = Asc(Char.s)-127
  EndIf  
EndProcedure


ProcedureDLL.s CSGridGadget_GetFormatComma(Gadget.l) ; Returns the comma-symbol of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ermitteln des Komma-Zeichens fr die formatierte Zahlenausgabe
  If H_GetGadget(Gadget.l) = 1
    ProcedureReturn Chr(CSGrid()\CommaSep+127)
  EndIf  
EndProcedure


ProcedureDLL CSGridGadget_SetCursor(Gadget.l,Col.b,Row.w) ; Sets the cursor to a Cell of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Cursors
  If H_GetGadget(Gadget.l) = 1
    If Col.b < CSGrid()\Cols And Col.b >= 0 And Row.w < CSGrid()\Rows And Row.w >= 0 And CSGrid()\hGadget <> 0
      If H_GetCellLockStatus(Col.b,Row.w) > -16
        H_SetCursor(0,Col.b,Row.w)
      EndIf
    EndIf  
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetCursorRange(Gadget.l,StartCol.b,StartRow.w,EndCol.b,EndRow.w) ; Sets the cursor to a range of Cells of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen eines Markierungsbereichs
  If H_GetGadget(Gadget.l) = 1
    If StartCol.b < CSGrid()\Cols And StartCol.b >= 0 And StartRow.w < CSGrid()\Rows And StartRow.w >= 0 And EndCol.b < CSGrid()\Cols And EndCol.b >= 0 And EndRow.w < CSGrid()\Rows And EndRow.w >= 0 And CSGrid()\hGadget <> 0
      If H_GetCellLockStatus(StartCol.b,StartRow.w) > -16
        H_SetCursor(0,StartCol.b,StartRow.w)
      EndIf
      If H_GetCellLockStatus(EndCol.b,EndRow.w) > -16      
        H_SetCursor(0,EndCol.b,EndRow.w)
      EndIf    
    EndIf
  EndIf
EndProcedure  


ProcedureDLL CSGridGadget_CopySelectionToClipboard(Gadget.l) ; Copies the actual cursor selection of a CS-Grid-Gadget to the clipboard
  ; PUBLIC-Funktion zum Kopieren der aktuellen Markierung in die Zwischenablage
  Protected tx.b,ty.w, tclip.s
  If H_GetGadget(Gadget.l) = 1
    If StartCol.b < CSGrid()\Cols And StartCol.b >= 0 And StartRow.w < CSGrid()\Rows And StartRow.w >= 0 And EndCol.b < CSGrid()\Cols And EndCol.b >= 0 And EndRow.w < CSGrid()\Rows And EndRow.w >= 0 And CSGrid()\hGadget <> 0
      If CSGrid()\ColCaptVisible = 1
        tclip = Chr(7)
        For tx = CSGrid()\ActColStart To CSGrid()\ActColEnd
          If H_GetColWidth(tx) > 0
            tclip + H_GetColCaption(tx)
            If tx < CSGrid()\ActColEnd
              tclip + Chr(9)
            EndIf            
          EndIf          
        Next
        tclip + Chr(13) + Chr(10)
      EndIf
      For ty = CSGrid()\ActRowStart To CSGrid()\ActRowEnd
        For tx = CSGrid()\ActColStart To CSGrid()\ActColEnd
          If H_GetColWidth(tx) > 0
            If H_GetCellLockStatus(tx,ty) > -16
              tclip + H_FormatCell(H_GetCellValue(tx,ty),H_GetColDataType(tx))
            EndIf
            If tx < CSGrid()\ActColEnd
              tclip + Chr(9)
            EndIf            
          EndIf
        Next
        If ty < CSGrid()\ActRowEnd
          tclip + Chr(13) + Chr(10)
        EndIf
      Next
      SetClipboardText(tclip)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_PasteClipboardToSelection(Gadget.l) ; Pastes the clipboard content to the actual cursor of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Einfgen des Inhaltes aus der Zwischenablage an die Cursor-Position
  Protected tClip.s,tpos.l, tline.s, tx.b, ty.w, fRedraw.b, tcell.s
  If H_GetGadget(Gadget.l) = 1
    tClip = GetClipboardText()
    fRedraw = CSGrid()\AutoRedraw
    CSGrid()\AutoRedraw = -1
    ; Spaltenkpfe ausblenden
    If Left(tClip.s,1) = Chr(7) 
      tpos = FindString(tClip,Chr(13)+Chr(10),2)
      If tpos > 0
        tClip = Right(tClip,Len(tClip)-tpos-1)
      EndIf
    EndIf    
    While Len(tClip.s) > 0 And (ty+CSGrid()\ActRowEnd) < CSGrid()\Rows
      tpos = FindString(tClip,Chr(13)+Chr(10),1)
      If tpos > 0
        tline = Left(tClip,tpos-1)
        tClip = Right(tClip,Len(tClip)-tpos-1)
      Else
        tline = tClip
        tClip = ""
      EndIf
      tx = 0
      While Len(tline) > 0 And (tx+CSGrid()\ActColEnd) < CSGrid()\Cols
        tpos = FindString(tline,Chr(9),1)
        If tpos > 0 
          tcell = Left(tline,tpos-1)
          tline = Right(tline,Len(tline)-tpos)
          tx + 1
        Else
          tcell = tline
          tline = ""
        EndIf
        If tcell <> ""
          H_SetCellValue(CSGrid()\ActColEnd+tx,CSGrid()\ActRowEnd+ty,tcell)
        EndIf
      Wend        
      ty + 1
    Wend
    CSGrid()\AutoRedraw = fRedraw
    H_DrawGrid(-1)
  EndIf  
EndProcedure


ProcedureDLL.b CSGridGadget_EventHandling(eventID.l,menueventID.l) ; Needs to be called for CS-Grid-Gadgets, if Windows-Event is rising
  ; PUBLIC-Funktion zum Verarbeiten eines Purebasic-Events
  Protected teventtype.l, teventgadget.l, ieventID.b, mPosX.w, mPosY.w, tleft.w
  teventtype.l = EventType()
  teventgadget.l = EventGadget()
  mPosX = WindowMouseX(WindowID) 
  mPosY = WindowMouseY(WindowID)

  Select teventtype.l
    Case #PB_EventType_Focus
      If H_GetGadget(teventgadget.l) = 0
        If CSGrid()\GridLock > -16 And CSGrid()\GridLock < 16 
          teventgadget.l = 0
        EndIf
      EndIf
    Case #PB_EventType_LeftClick
      ;If CSGrid_DetailsFocusGadget = 0
        H_GetFocusedGrid()
      ;EndIf
  EndSelect
  Select eventID 
    Case #PB_Event_Gadget
      ResetList(CSGrid())
      While NextElement(CSGrid())  
        Select teventgadget.l
          Case CSGrid()\hHscrollGadget
            If CSGrid()\InputMode = 0
              H_Scroll(GetGadgetState(CSGrid()\hHscrollGadget),0)
              ieventID.b = #CSGRID_Event_ScrollH
              Break
            EndIf
          Case CSGrid()\hVscrollGadget
            If CSGrid()\InputMode = 0
              H_Scroll(GetGadgetState(CSGrid()\hVscrollGadget),1)
              ieventID.b = #CSGRID_Event_ScrollV
              Break
            EndIf
          ;Case CSGrid()\hImageGadget
          Default
            ;Debug "TABLE: MouseX:"+Str(WindowMouseX())+"  MouseY:"+Str(WindowMouseY())
            If CSGrid()\GridLock > -16 And CSGrid()\GridLock < 16 And CSGrid()\InputMode = 0 And CSGrid_ActGridhGadget = CSGrid()\hGadget
            ;If CSGrid()\GridLock > -16 And CSGrid()\GridLock < 16 And CSGrid_ActGridhGadget = CSGrid()\hGadget
              Select teventtype.l
                Case #PB_EventType_LeftDoubleClick
                  If H_SortColbyMouse() = -1
                    ; *** TODO: Abhngig vom Zell-Eingabeformat
                    
                    If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1 
                      tleft = CSGrid()\LeftAbs
                    Else
                      tleft = CSGrid()\Left
                    EndIf
                    If (CSGrid()\RowCaptVisible < 1 Or mPosX > tleft+CSGrid()\RowCaptWidth) 
                      If H_CellInput(1)
                        ieventID.b = #CSGRID_Event_InputNo
                      Else
                        ieventID.b = #CSGRID_Event_InputStart
                      EndIf
                    EndIf                    
                  Else
                    ieventID.b = 18
                  EndIf
                Default
                  ieventID.b = H_MoveCursorbyMouse(0,mPosX,mPosY)
                  CSGrid()\InputMode = 0
              EndSelect
              If CSGrid()\ParentGrid <> 0
                ;H_DrawGrid(1)
                H_DrawScrollbars(1)
              EndIf
              Break
            Else
              If CSGrid()\InputMode <> 0
                H_MouseInput(teventtype.l)
                Break
              EndIf
            EndIf
            ;Break          
        EndSelect
      Wend
    Case #WM_LBUTTONUP
      If CSGrid()\InputMode <= 0
        ;ResetList(CSGrid())
        ;While NextElement(CSGrid())
          If CSGrid()\GridLock > -16 And CSGrid()\GridLock < 16 
            ieventID.b = H_MoveCursorbyMouse(2,mPosX,mPosY)
          EndIf
        ;Wend
      EndIf  
  EndSelect
  If H_GetGadget(CSGrid_ActGridhGadget) = 1
    If CSGrid()\GridLock > -16 And CSGrid()\GridLock < 16 
      Select eventID
        Case #PB_Event_Menu
          Select menueventID ;EventMenu()
            Case #EventID_Left
              H_MoveCursor(0,-1,0)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_Up
              H_MoveCursor(0,0,-1)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_Right
              H_MoveCursor(0,1,0)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_Down
              H_MoveCursor(0,0,1)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_SLeft
              H_MoveCursor(2,-1,0)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_SUp
              H_MoveCursor(2,0,-1)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_SRight
              H_MoveCursor(2,1,0)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_SDown
              H_MoveCursor(2,0,1)
              ieventID.b = #CSGRID_Event_CellSelect
            Case #EventID_Return
              If CSGrid()\InputMode > 0
                H_CellInput(0)
                ieventID.b = #CSGRID_Event_InputEnd
              Else
                ; *** TODO: Abhngig vom Zell-Eingabeformat  
                If H_CellInput(1)
                  ieventID.b = #CSGRID_Event_InputStart
                Else
                  ieventID.b = #CSGRID_Event_InputNo
                EndIf
              EndIf
            Case #EventID_ESC
              If CSGrid()\ParentGrid > 0 And CSGrid()\InputMode = 0
                ieventID = H_DisableDetailsObject()
              Else
                H_CellInput(-1)
                If CSGrid()\ParentGrid > 0 And CSGrid()\InputMode = 0
                  ;H_DrawGrid(1)
                  ;CompilerIf #PB_Compiler_OS = #PB_OS_Windows
                    ; TODO: GGF. WINDOW REDRAW - DENN ES BLEIBT IMMER EINER GRAUER FLECK, WENN SUB-GRID
                  ;CompilerEndIf
                EndIf
                ieventID.b = #CSGRID_Event_InputCancel
              EndIf
            Case #EventID_Space
              ieventID = H_EnableDetailsObject()
          EndSelect
      EndSelect
    EndIf
  Else
    teventgadget.l = 0
  EndIf
  ProcedureReturn ieventID
EndProcedure


ProcedureDLL.b CSGridGadget_EventExecute(Gadget.l,CSEvent.b) ; Send a event to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Ausfhren eines Events in einem CS-Grid-Gadget
  Protected resp.b
  resp = -1
  If H_GetGadget(Gadget.l) = 1
    Select CSEvent.b
      Case #CSGRID_Event_ScrollH ; H-Scroll
        If CSGrid()\InputMode = 0
          H_Scroll(GetGadgetState(CSGrid()\hHscrollGadget),0)
          resp = 1
        EndIf
      Case #CSGRID_Event_ScrollV ; V-Scroll
        If CSGrid()\InputMode = 0
          H_Scroll(GetGadgetState(CSGrid()\hVscrollGadget),1)
          resp = 1
        EndIf      
      Case #CSGRID_Event_InputStart ; Start input
        If H_CellInput(1)
          resp = 1
        EndIf        
      Case #CSGRID_Event_InputEnd ; End input
        If CSGrid()\InputMode > 0
          H_CellInput(0)
          resp = 1
        EndIf        
      Case #CSGRID_Event_InputCancel ; Cancel input
        H_CellInput(-1)
        If CSGrid()\ParentGrid > 0 And CSGrid()\InputMode = 0
          ;H_DrawGrid(1)
          ;CompilerIf #PB_Compiler_OS = #PB_OS_Windows
            ; TODO: GGF. WINDOW REDRAW - DENN ES BLEIBT IMMER EINER GRAUER FLECK, WENN SUB-GRID
          ;CompilerEndIf
          resp = 1
        EndIf      
      Case #CSGRID_Event_DetailsOpened ; Details opened
        H_EnableDetailsObject()
        resp = 1
      Case #CSGRID_Event_DetailsClosed ; Details closed
        If CSGrid()\ParentGrid > 0 And CSGrid()\InputMode = 0
          ieventID = H_DisableDetailsObject()
          resp = 1
        EndIf
    EndSelect
  EndIf
  ProcedureReturn resp
EndProcedure


ProcedureDLL CSGridGadget_AddRow(Gadget.l,Position.w) ; Adds a new row to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Hinzufgen einer Zeile zu einem CS-Grid-Gadget
  If H_GetGadget(Gadget.l) = 1
    CSGridGadget_AddRowWithContent(Gadget.l,Position.w,"",0)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_AddRowWithContent(Gadget.l,Position.w,Text$,ImageID.l) ; Adds a new row with content like AddGadgetItem to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Hinzufgen einer Zeile mit Inhalt (Spalten mit Tab [ASC10] getrennt) zu einem CS-Grid-Gadget
  Protected tActMatrixPos.l, tCols.b, tpos.w, x.b
  If H_GetGadget(Gadget.l) = 1
    Position.w - 1
    If Position.w >= CSGrid()\Rows Or Position.w < -1
      Position.w = CSGrid()\Rows-1
    EndIf
    tCols = CSGrid()\Cols
    If H_GetCell(tCols-1,Position.w) <= -1
      tpos.w = CSGrid()\CellMatrixStartID-1
      If tpos > 0
        SelectElement(CSGrid_Cell(),tpos)
      Else
        ResetList(CSGrid_Cell())
      EndIf
    EndIf
    For x = 0 To tCols-1
      AddElement(CSGrid_Cell())
      If Len(text$) > 0
        tpos = FindString(Text$,Chr(10),1)
        If tpos > 0
          CSGrid_Cell()\content = Left(Text$,tpos-1)
          Text$ = Right(Text$,Len(Text$)-tpos)
        Else
          CSGrid_Cell()\content = Text$
          Text$ = ""
        EndIf
      EndIf
    Next
    CSGrid()\rows + 1
    CSGrid()\cells = tCols * CSGrid()\Rows
    tActMatrixPos.l = CSGrid()\CellMatrixStartID
    If CSGrid()\AutoSort > -1 
      H_DoColSorting(CSGrid()\SortCol,CSGrid()\SortDir)
    EndIf            
    ResetList(CSGrid())
    While NextElement(CSGrid())
      If CSGrid()\CellMatrixStartID > tActMatrixPos.l
        CSGrid()\CellMatrixStartID + tCols
      EndIf
    Wend
    ResetList(CSGrid_Row())
    While NextElement(CSGrid_Row())
      If CSGrid_Row()\row > Position.w
        CSGrid_Row()\row+1
      EndIf
    Wend
    H_DrawScrollbars(-1)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_RemoveRow(Gadget.l,Position.w) ; Removes a row of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Enternen einer Zeile
  Protected tActMatrixPos.l, tCols.b, tpos.w, x.b
  If H_GetGadget(Gadget.l) = 1
    If Position.w > CSGrid()\Rows
      Position.w = CSGrid()\Rows-1
    EndIf
    tCols = CSGrid()\Cols
    If H_GetCell(tCols-1,Position.w) > -1
      For x = 0 To tCols-1
        DeleteElement(CSGrid_Cell())
      Next
      CSGrid()\rows - 1
      CSGrid()\cells = tCols * CSGrid()\Rows
      tActMatrixPos.l = CSGrid()\CellMatrixStartID
      H_DrawGrid(-1)
      ResetList(CSGrid())
      While NextElement(CSGrid())
        If CSGrid()\CellMatrixStartID > tActMatrixPos.l
          CSGrid()\CellMatrixStartID - tCols
        EndIf
      Wend  
      ResetList(CSGrid_Row())
      While NextElement(CSGrid_Row())
        If CSGrid_Row()\row >= Position.w
          CSGrid_Row()\row-1
        EndIf
      Wend
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_AddCol(Gadget.l,Position.b) ; Adds a new col to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Hinzufgen einer Spalte zu einem CS-Grid-Gadget
  If H_GetGadget(Gadget.l) = 1
    CSGridGadget_AddColWithContent(Gadget.l,Position.b,"",0)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_AddColWithContent(Gadget.l,Position.b,Content.s,ImageID.l) ; Adds a new col with content to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Hinzufgen einer Spalte mit Inhalt (Spalten mit Tab [ASC10] getrennt) zu einem CS-Grid-Gadget
  Protected tActMatrixPos.l, tpos.w, y.w, tActCell.l, tRows.w
  If H_GetGadget(Gadget.l) = 1
    position.b - 1
    If Position.b >= CSGrid()\Cols
      Position.b = CSGrid()\Cols-1
    EndIf
    If CSGrid()\Cols > 0
      For y = 0 To CSGrid()\Rows-1
        If H_GetCell(Position.b+y.w,y.w) <= -1
          tpos.w = CSGrid()\CellMatrixStartID-1
          If tpos > 0
            SelectElement(CSGrid_Cell(),tpos)
          Else
            ResetList(CSGrid_Cell())
          EndIf          
        EndIf
        AddElement(CSGrid_Cell())
        If Len(Content.s) > 0
          tpos = FindString(Content.s,Chr(10),1)
          If tpos > 0
            CSGrid_Cell()\content = Left(Content.s,tpos-1)
            Content.s = Right(Content.s,Len(Content.s)-tpos)
          Else
            CSGrid_Cell()\content = Content.s
            Content.s = ""
          EndIf
        EndIf
      Next
      CSGrid()\cols + 1
      tRows = CSGrid()\rows
      CSGrid()\cells = CSGrid()\Cols * CSGrid()\Rows
      tActMatrixPos.l = CSGrid()\CellMatrixStartID
      H_DrawScrollbars(-1)
      ResetList(CSGrid())
      While NextElement(CSGrid())
        If CSGrid()\CellMatrixStartID > tActMatrixPos.l
          CSGrid()\CellMatrixStartID + tRows
        EndIf
      Wend
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col > Position.b
          CSGrid_Col()\col+1
        EndIf
      Wend
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_RemoveCol(Gadget.l,Position.b) ; Removes a col of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Entfernen einer Spalte 
  Protected tActMatrixPos.l, tpos.w, y.w, tActCell.l, tRows.w
  If H_GetGadget(Gadget.l) = 1
    If Position.b > CSGrid()\Cols
      Position.b = CSGrid()\Cols-1
    EndIf
    If CSGrid()\Cols > 0
      For y = 0 To CSGrid()\Rows-1
        If H_GetCell(Position.b-y.w,y.w) > -1
          DeleteElement(CSGrid_Cell())
        EndIf
      Next
      CSGrid()\cols - 1
      tRows = CSGrid()\rows
      CSGrid()\cells = CSGrid()\Cols * CSGrid()\Rows
      tActMatrixPos.l = CSGrid()\CellMatrixStartID
      H_DrawGrid(-1)
      ResetList(CSGrid())
      While NextElement(CSGrid())
        If CSGrid()\CellMatrixStartID > tActMatrixPos.l
          CSGrid()\CellMatrixStartID - tRows
        EndIf
      Wend
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col >= Position.b
          CSGrid_Col()\col-1
        EndIf
      Wend      
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_RemoveAllCells(Gadget.l) ; Removes all existing columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Entfernen smtlicher Zellen
  Protected c.l
  If H_GetGadget(Gadget.l) = 1
    If H_GetCell(0,0) > -1
      For c = 0 To CSGrid()\cells
        DeleteElement(CSGrid_Cell())
      Next
      CSGrid()\cells = 0
      CSGrid()\cols = 0
      CSGrid()\rows = 0
      CSGrid()\ActColStart = -1
      CSGrid()\ActRowStart = -1
      CSGrid()\ActColEnd = -1
      CSGrid()\ActRowEnd = -1
      CSGrid()\ActXStart = 0
      CSGrid()\ActYStart = 0
      CSGrid()\ActXEnd = 0
      CSGrid()\ActYEnd = 0
      CSGrid()\ScrollX = 0
      CSGrid()\ScrollY = 0
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_RemoveAllCells2(Gadget.l) ; Removes all existing columns of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Entfernen smtlicher Zellen ohne Spalten-Infos zurck zu setzen
  Protected c.l
  If H_GetGadget(Gadget.l) = 1
    If H_GetCell(0,0) > -1
      For c = 0 To CSGrid()\cells
        DeleteElement(CSGrid_Cell())
      Next
      CSGrid()\cells = 0
      CSGrid()\rows = 0
      CSGrid()\ActColStart = -1
      CSGrid()\ActRowStart = -1
      CSGrid()\ActColEnd = -1
      CSGrid()\ActRowEnd = -1
      CSGrid()\ActXStart = 0
      CSGrid()\ActYStart = 0
      CSGrid()\ActXEnd = 0
      CSGrid()\ActYEnd = 0
      CSGrid()\ScrollX = 0
      CSGrid()\ScrollY = 0
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure



ProcedureDLL CSGridGadget_SetFocus(Gadget.l,NoRedraw.b=-1) ; Sets Focus to a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Setzen des Fokus eines CS-Grid-Gadgets
  CSGrid_ActGridhGadget.l = Gadget.l
  If NoRedraw <> 1
    ResetList(CSGrid())
    While NextElement(CSGrid())
      H_DrawGrid(-1)
    Wend
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_Resize(Gadget.l,x.w,y.w,width.w,height.w,NoRedraw.b=-1) ; Resizes a CS-Grid-Gadget
  ; PUBLIC-Funktion zum Positionieren und Skalieren eines CS-Grid-Objektes
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\Left = x.w
    CSGrid()\Top = y.w
    CSGrid()\Width = width.w
    CSGrid()\Height = height.w
    If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1
      x = CSGrid()\LeftAbs+4
      y = CSGrid()\TopAbs+4
    Else
      x = CSGrid()\Left+2
      y = CSGrid()\Top+2
    EndIf    
    ResizeGadget(CSGrid()\hGadget,CSGrid()\Left,CSGrid()\Top,CSGrid()\Width,CSGrid()\Height)
    If CSGrid()\hInput <> 0
      ;ResizeGadget(CSGrid()\hInput,x+CSGrid()\ActXEnd,y+CSGrid()\ActYEnd,H_GetColWidth(CSGrid()\ActColStart)-1,#PB_Ignore)
    EndIf
    If NoRedraw < 1
      H_DrawScrollbars(1) 
    EndIf
    H_GetLastVisColRow()
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_SetAbsPosition(Gadget.l,x.w,y.w) ; Defines the absolute position to the window of a CS-Grid-Gadget
  ; PUBLIC-Funktion zum manuellen Definieren der absoluten Position des CS-Grid-Objektes zum Fenster (wenn Element eines Parent-Objektes)
  If H_GetGadget(Gadget.l) = 1
    CSGrid()\LeftAbs = x.w
    CSGrid()\TopAbs = y.w
    ;Debug "CSGrid()\LeftAbs"+Str(CSGrid()\LeftAbs)
    ;Debug "CSGrid()\TopAbs"+Str(CSGrid()\TopAbs)
  EndIf
EndProcedure


ProcedureDLL CSGridGadget_FreeGadget(Gadget.l) ; Removes a CS-Grid-Gadget and frees memory
  ; PUBLIC-Funktion zum Entfernen eines CS-Grid-Objektes
  If CSGrid()\hGadget <> 0
    FreeImage(CSGrid()\hImage)
    FreeGadget(CSGrid()\hImageGadget)
    FreeGadget(CSGrid()\hVscrollGadget)
    FreeGadget(CSGrid()\hHscrollGadget)
    FreeGadget(CSGrid()\hGadget)
    If CSGrid()\hInput <> 0
      FreeGadget(CSGrid()\hInput)
    EndIf
    CSGrid()\hImage = 0
    CSGrid()\hImageGadget = 0
    CSGrid()\hVscrollGadget = 0
    CSGrid()\hHscrollGadget = 0
    CSGrid()\hGadget = 0
    CSGrid()\hInput = 0
    ClearList(CSGrid_Cell())
    ClearList(CSGrid_Col())
    H_RemoveShortCuts(0)
  EndIf
EndProcedure



; ***********************************************************
;- INTERNAL FUNCTIONS / Hilfsfunktionen
; ***********************************************************

Procedure H_DrawGrid(ManualRedraw.b)
  ; Hilfsfunktion zum Zeichnen des Grids
  Protected imgID.l, ActCol.b, ActWidth.w, ActRow.w, ActX.w, ActY.w, ActCell.l, MaxX.w, MaxY.w, tCapt.s, tTo.w,tColor.l, tStatus.b, tHeight.b, tActX.w, tOrient.b
  If CSGrid()\hImage <> 0 And (CSGrid()\AutoRedraw = 1 Or ManualRedraw = 1)
    imgID = ImageID(CSGrid()\hImage)
    StartDrawing(ImageOutput(CSGrid()\hImage))
    Box(0,0,CSGrid()\ImgWidth,CSGrid()\ImgHeight,CSGrid()\Color_Backgr)
    If CSGrid()\Cells > 0
      DrawingMode(#PB_2DDrawing_Transparent)
      If CSGrid()\Font <> 0 
        DrawingFont(CSGrid()\Font)
      EndIf
      ActCol = CSGrid()\ScrollX
      ActRow = CSGrid()\ScrollY
      If CSGrid()\ColCaptVisible = 1
        If CSGrid()\RowCaptVisible = 1
          If CSGrid()\GridVisible = 1
            Box(ActX,ActY,CSGrid()\RowCaptWidth-1,CSGrid()\DefGridHeight-1,CSGrid()\Color_CaptBack)
          Else
            Box(ActX,ActY,CSGrid()\RowCaptWidth,CSGrid()\DefGridHeight,CSGrid()\Color_CaptBack)
          EndIf
          ActX + CSGrid()\RowCaptWidth         
        EndIf
        While ActCol < CSGrid()\Cols And ActX < CSGrid()\ImgWidth
          ActWidth.w = H_GetColWidth(ActCol.b)
          tCapt.s = H_GetColCaption(ActCol.b)
          tOrient.b = H_GetColCaptOrient(ActCol.b)
          If ActCol >= CSGrid()\ActColStart And ActCol <= CSGrid()\ActColEnd
            tColor = CSGrid()\Color_CaptFocus
          Else
            tColor = CSGrid()\Color_CaptBack
          EndIf           
          If CSGrid()\GridVisible = 1
            Box(ActX,ActY,ActWidth-1,CSGrid()\DefGridHeight-1,tColor)
          Else
            Box(ActX,ActY,ActWidth,CSGrid()\DefGridHeight,tColor)
          EndIf        
          FrontColor(CSGrid()\Color_CellFore) 
          H_DrawCellContent(tCapt.s,ActX + 2,ActY+2,ActWidth,0,tOrient)
          ;DrawText(ActX + 2, ActY+2,tCapt.s,CSGrid()\Color_CellFore)
          If CSGrid()\SortCol = ActCol
            H_DrawSortSymbol(ActX,ActY,ActWidth,CSGrid()\SortDir)
          EndIf 
          ActCol+1
          ActX+ActWidth        
        Wend
        ActCol = CSGrid()\ScrollX
        ActX = 0
        ActY = CSGrid()\DefGridHeight
      EndIf    
      While ActRow < CSGrid()\Rows And ActY < CSGrid()\ImgHeight
        If CSGrid()\RowCaptVisible = 1
          tCapt.s = H_GetRowCaption(ActRow.w)
          If ActRow >= CSGrid()\ActRowStart And ActRow <= CSGrid()\ActRowEnd
            tColor = CSGrid()\Color_CaptFocus
          Else
            tColor = CSGrid()\Color_CaptBack
          EndIf
          tHeight = H_GetRowHeight(ActRow)
          If CSGrid()\GridVisible = 1
            Box(ActX,ActY,CSGrid()\RowCaptWidth-1,tHeight-1,tColor)
          Else
            Box(ActX,ActY,CSGrid()\RowCaptWidth,tHeight,tColor)
          EndIf        
          FrontColor(CSGrid()\Color_CellFore) 
          DrawText(ActX + 2, ActY+2,tCapt.s,CSGrid()\Color_CellFore) 
          If CSGrid()\RowExpand = 1
            If H_GetRowDetailsHandle(ActRow) <> 0
              H_DrawDetailsSymbol(ActX,ActY,CSGrid()\RowCaptWidth,CSGrid_Row()\DetailsVisible)
            EndIf
          EndIf        
          ActX + CSGrid()\RowCaptWidth
        EndIf      
        
        tActX = ActX        
        While ActCol < CSGrid()\Cols And ActX < CSGrid()\ImgWidth
          ActCell = (CSGrid()\Cols * ActRow) + ActCol    
          SelectElement(CSGrid_Cell(),ActCell)  
          ActWidth.w = H_GetColWidth(ActCol.b)
          ;Debug "X:" + Str(ActCol)+" Y:" + Str(ActRow) + " WIDTH:"+Str(ActWidth)
          If ActCol = CSGrid()\ActColStart And ActRow = CSGrid()\ActRowStart 
            CSGrid()\ActXStart = ActX
            CSGrid()\ActYStart = ActY
          EndIf
          If ActCol = CSGrid()\ActColEnd And ActRow = CSGrid()\ActRowEnd 
            CSGrid()\ActXEnd = ActX
            CSGrid()\ActYEnd = ActY
          EndIf
          tStatus.b = H_GetCellLockStatus(ActCol,ActRow)
          If tStatus.b <= -16
            tColor = CSGrid()\Color_CellLock
          Else
            If ActCol >= CSGrid()\ActColStart And ActRow >= CSGrid()\ActRowStart And ActCol <= CSGrid()\ActColEnd And ActRow <= CSGrid()\ActRowEnd
              If tStatus.b < 0 Or CSGrid()\GridLock < 0 
                tColor = CSGrid()\Color_CellLoFoc
              Else
                If CSGrid()\hGadget = CSGrid_ActGridhGadget
                  tColor = CSGrid()\Color_CellFocus
                Else
                  tColor = CSGrid()\Color_CellFocusInact
                EndIf
              EndIf
            Else
              If tStatus.b < 0 Or CSGrid()\GridLock < 0
                tColor = CSGrid()\Color_CellLock
              Else                
                tColor = H_GetCellColorBack(ActCol,ActRow)
              EndIf
            EndIf
          EndIf          
          If CSGrid()\GridVisible = 1
            Box(ActX,ActY,ActWidth,tHeight,CSGrid()\Color_Grid)
            Box(ActX,ActY,ActWidth-1,tHeight-1,tColor)
          Else
            Box(ActX,ActY,ActWidth,tHeight,tColor)
          EndIf
          FrontColor(CSGrid()\Color_CellFore) 
          H_DrawCellContent(CSGrid_Cell()\content,ActX + 2,ActY+2,ActWidth.w,H_GetColDataType(ActCol),-1,tHeight)
          ActCol+1
          ActX+ActWidth
          NextElement(CSGrid_Cell())        
        Wend
        MaxX = ActX-1
        ActX = 0
        ActY+tHeight
        If CSGrid()\RowExpand = 1 And CSGrid()\RowCaptVisible = 1
          If H_GetRowDetailsHandle(ActRow) <> 0
            If CSGrid_Row()\DetailsVisible = 1 And CSGrid_Row()\DetailsHeight > 0
              H_PositionDetailsObject(ActX,ActY,CSGrid_Row()\DetailsHeight,CSGrid_Row()\DetailsVisible,CSGrid_Row()\hDetails)
              ActY = ActY + CSGrid_Row()\DetailsHeight
            EndIf
          EndIf
        EndIf
        CSGrid()\LastVisCol = ActCol-1
        ActCol = CSGrid()\ScrollX
        ActRow+1      
      Wend
      CSGrid()\LastVisRow = ActRow-1   

      ActX = tActX
      ActCol = CSGrid()\ScrollX

      ResetList(CSGrid_Cell())        
      While ActCol < CSGrid()\Cols And ActX < CSGrid()\ImgWidth
        ActCell = (CSGrid()\Cols * ActRow) + ActCol    
        SelectElement(CSGrid_Cell(),ActCell)  
        ActWidth.w = H_GetColWidth(ActCol.b)        
        If ActCol = CSGrid()\ActColStart And ActRow = CSGrid()\ActRowStart 
          CSGrid()\ActXStart = ActX
          CSGrid()\ActYStart = ActY
        EndIf
        If ActCol = CSGrid()\ActColEnd And ActRow = CSGrid()\ActRowEnd 
          CSGrid()\ActXEnd = ActX
          CSGrid()\ActYEnd = ActY
        EndIf
      
        H_DrawSummary(ActX,ActY,ActWidth,ActCol)
        ActCol+1
        ActX+ActWidth
        NextElement(CSGrid_Cell())        
      Wend
    EndIf    
    StopDrawing()
    SetGadgetState(CSGrid()\hImageGadget,ImageID(CSGrid()\hImage))
  EndIf
EndProcedure


Procedure H_GetLastVisColRow()
  ; Hilfsfunktion zum Ermitteln der letzten, sichtbaren Spalte und Zeile
  Protected ActCol.b, ActWidth.w, ActRow.w, ActX.w, ActY.w
  ActCol = CSGrid()\ScrollX
  If CSGrid()\RowCaptVisible = 1
    ActX + CSGrid()\RowCaptWidth
  EndIf  
  While ActCol < CSGrid()\Cols And ActX < CSGrid()\ImgWidth
    ActWidth.w = H_GetColWidth(ActCol.b)
    ActCol+1
    ActX+ActWidth
  Wend
  CSGrid()\LastVisCol = ActCol-1
  If CSGrid()\ColCaptVisible = 1
    ActY = CSGrid()\DefGridHeight
  EndIf    
  ActRow = CSGrid()\ScrollY
  While ActRow < CSGrid()\Rows And ActY < CSGrid()\ImgHeight
    ActY+H_GetRowHeight(ActRow) ;CSGrid()\DefGridHeight
    ActRow+1      
  Wend
  CSGrid()\LastVisRow = ActRow
EndProcedure


Procedure H_Scroll(Value.w,Vertical.b)
  ; Hilfsfunktion zum Scrollen der Tabelle
  If Vertical.b = 1
    If CSGrid()\LastVisRow < CSGrid()\Rows And Value < CSGrid()\Rows-1
      CSGrid()\ScrollY = Value
    EndIf
  Else
    If CSGrid()\LastVisCol < CSGrid()\Cols And Value < CSGrid()\Cols-1 
      CSGrid()\ScrollX = Value
    EndIf
  EndIf
  H_GetLastVisColRow()
  H_DrawScrollbars(-1)
EndProcedure


Procedure H_DrawScrollbars(ReScale.b)
  ; Hilfsfunktion zum Zeichnen der Scrollbalken
  Protected tmax.w, hTarget.b, vTarget.b,tadd.b, theight.w, n.w
  OpenGadgetList(CSGrid()\hGadget)  
    For n.w = 0 To CSGrid()\Rows
      theight + H_GetRowHeight(n)
      If H_GetRowDetailsHandle(n) <> 0
        If CSGrid_Row()\DetailsVisible = 1
          theight + CSGrid_Row()\DetailsHeight
        EndIf
      EndIf
    Next
    If CSGrid()\ColCaptVisible = 1
      tadd + 1
      theight + CSGrid()\DefGridHeight
    EndIf
    If CSGrid()\ShowColSummary = 1
      tadd + 1
      theight + CSGrid()\DefGridHeight
    EndIf
    ;Debug theight
    If CSGrid()\ImgHeight < theight Or CSGrid()\ScrollY > 0
      vTarget = 0
      If ReScale.b = 1
        If tadd = 0
          tadd = 1
        EndIf
        tmax = (CSGrid()\Rows - (CSGrid()\LastVisRow - CSGrid()\ScrollY)) + tadd
        If CSGrid()\hVscrollGadget <> 0
          FreeGadget(CSGrid()\hVscrollGadget)
        EndIf
        CSGrid()\hVscrollGadget = ScrollBarGadget(#PB_Any,CSGrid()\Width-#ScrollbarSize-3,0,#ScrollbarSize,CSGrid()\ImgHeight,0,tmax,1,#PB_ScrollBar_Vertical)
      EndIf
      SetGadgetState(CSGrid()\hVscrollGadget,CSGrid()\ScrollY)
    Else
      If CSGrid()\hVscrollGadget <> 0
        vTarget = 1
      EndIf
    EndIf
    If CSGrid()\LastVisCol < CSGrid()\Cols-1 Or CSGrid()\ScrollX > 0
      hTarget = 0
      If ReScale.b = 1
        tmax = CSGrid()\ScrollX + CSGrid()\Cols - CSGrid()\LastVisCol
        If CSGrid()\LastVisCol >= CSGrid()\Cols-1
          tmax = CSGrid()\ScrollX
        EndIf 
        If CSGrid()\hHscrollGadget <> 0
          FreeGadget(CSGrid()\hHscrollGadget)
        EndIf
        CSGrid()\hHscrollGadget = ScrollBarGadget(#PB_Any,0,CSGrid()\Height-#ScrollbarSize-3,CSGrid()\ImgWidth,#ScrollbarSize,0,tmax,1)
      EndIf
      SetGadgetState(CSGrid()\hHscrollGadget,CSGrid()\ScrollX)
    Else
      If CSGrid()\hHscrollGadget <> 0
        hTarget = 1
      EndIf
    EndIf
  CloseGadgetList()
  H_HideScrollbars(hTarget,vTarget,ReScale)
  H_DrawGrid(-1)
EndProcedure


Procedure H_HideScrollbars(hTarget.b,vTarget.b,Must.b)
  ; Hilfsfunktion zum Anzeigen/Ausblenden der Scrollbalken
  Protected tupd.b
  If CSGrid()\ScrollBarHVis <> hTarget Or Must = 1
      HideGadget(CSGrid()\hHscrollGadget,hTarget)
      CSGrid()\ScrollBarHVis = hTarget
      tupd = 1
  EndIf
  If CSGrid()\ScrollBarVVis <> vTarget Or Must = 1
      HideGadget(CSGrid()\hVscrollGadget,vTarget)
      CSGrid()\ScrollBarVVis = vTarget 
      tupd = 1
  EndIf
  If tupd = 1
    If vTarget = 0
      CSGrid()\ImgWidth = CSGrid()\Width-#ScrollbarSize-3
    Else
      CSGrid()\ImgWidth = CSGrid()\Width-3
    EndIf
    If CSGrid()\ImgWidth <= 0
      CSGrid()\ImgWidth = 1
    EndIf
    If hTarget = 0
      CSGrid()\ImgHeight = CSGrid()\Height-#ScrollbarSize-3
    Else
      CSGrid()\ImgHeight = CSGrid()\Height-3
    EndIf 
    If CSGrid()\ImgHeight <= 0
      CSGrid()\ImgHeight = 1
    EndIf
    FreeImage(CSGrid()\hImage)
    CSGrid()\hImage = CreateImage(#PB_Any, CSGrid()\ImgWidth,CSGrid()\ImgHeight)
    ResizeGadget(CSGrid()\hImageGadget,0,0,CSGrid()\ImgWidth,CSGrid()\ImgHeight)
    ResizeGadget(CSGrid()\hVscrollGadget,CSGrid()\Width-#ScrollbarSize-3,0,#ScrollbarSize,CSGrid()\ImgHeight)
    ResizeGadget(CSGrid()\hHscrollGadget,0,CSGrid()\Height-#ScrollbarSize-3,CSGrid()\ImgWidth,#ScrollbarSize)    
  EndIf
EndProcedure


Procedure.b H_CheckIfColSetExists(Col.b)
  ; Hilfsfunktion die ermittelt, ob fr eine Spalte ein Informations-Set angelegt wurde (1=JA, -1=Nein)
  Protected tfound.b
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      tfound = 1
    Else
      tfound = -1
      If Col.b < CSGrid()\Cols
        ResetList(CSGrid_Col())
        While NextElement(CSGrid_Col())
          If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
            tfound = 1
            Break
          EndIf
        Wend
      EndIf
    EndIf
  Else
    tfound = -1
  EndIf
  ProcedureReturn tfound
EndProcedure


Procedure.b H_CheckIfRowSetExists(Row.w)
  ; Hilfsfunktion die ermittelt, ob fr eine Zeile ein Informations-Set angelegt wurde (1=JA, -1=Nein)
  Protected tfound.b
  If CountList(CSGrid_Row()) > 0
    If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
      tfound = 1
    Else
      tfound = -1
      If Row.w < CSGrid()\Rows
        ResetList(CSGrid_Row())
        While NextElement(CSGrid_Row())
          If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
            tfound = 1
            Break
          EndIf
        Wend
      EndIf
    EndIf
  EndIf
  ProcedureReturn tfound
EndProcedure


Procedure H_MoveCursor(tMode.b,HDir.b,VDir.b)
  ; Hilfsfunktion zum Bewegen des Cursor
  Protected tCol.b,tRow.w
  If tMode = 2
    tCol = CSGrid()\ActColEnd
    tRow = CSGrid()\ActRowEnd
    If (CSGrid()\ActColEnd+HDir.b) < CSGrid()\Cols And (CSGrid()\ActColEnd+HDir.b) >= 0
      tCol + HDir.b
    EndIf
    If (CSGrid()\ActRowEnd+VDir.b) < CSGrid()\Rows And (CSGrid()\ActRowEnd+VDir.b) >= 0
      tRow + VDir.b
    EndIf
  Else
    tCol = CSGrid()\ActColStart
    tRow = CSGrid()\ActRowStart
    If (CSGrid()\ActColStart+HDir.b) < CSGrid()\Cols And (CSGrid()\ActColStart+HDir.b) >= 0
      tCol + HDir.b
    EndIf
    If (CSGrid()\ActRowStart+VDir.b) < CSGrid()\Rows And (CSGrid()\ActRowStart+VDir.b) >= 0
      tRow + VDir.b
    EndIf
  EndIf
  ;Debug "CSGrid()\ActColStart" + Str(CSGrid()\ActColStart) + "  HDir.b"+Str(HDir.b)+"  CSGrid()\Cols"+Str(CSGrid()\Cols)
  ;Debug "CSGrid()\ActRowStart" + Str(CSGrid()\ActRowStart) + "  VDir.b"+Str(VDir.b)+"  CSGrid()\Rows"+Str(CSGrid()\Rows)
  While (H_GetCellLockStatus(tCol,tRow) <= -16 Or H_GetColWidth(tCol) <= 0) And tCol >= 0 And tCol < CSGrid()\Cols And tRow >= 0 And tRow < CSGrid()\Rows
    tCol + HDir.b
    tRow + VDir.b
  Wend
  If tCol >= 0 And tCol < CSGrid()\Cols And tRow >= 0 And tRow < CSGrid()\Rows
    H_SetCursor(tMode.b,tCol.b,tRow.w)
  EndIf
  ProcedureReturn 0
EndProcedure


Procedure.b H_MoveCursorbyMouse(tMode.b,mPosX.w,mPosY.w)
  ; Hilfsfunktion zum Setzen des Cursors auf Basis der Mausposition
  ; tMode 0 = Start/End-Position setzen
  ; tMode 1 = Nur Start-Position setzen
  ; tMode 2 = Nur End-Position setzen
  Protected ActCol.b, ActWidth.w, ActRow.w, ActX.w, ActY.w,tCol.b,tRow.w,tEvent.b,tleft.w,ttop.w, theight.b
  If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1
    tleft = CSGrid()\LeftAbs
    ttop = CSGrid()\TopAbs 
  Else
    tleft = CSGrid()\Left
    ttop = CSGrid()\Top
  EndIf  
  If mPosX >=tleft And mPosX <= (tleft+CSGrid()\ImgWidth) And mPosY >= ttop And mPosY <= (ttop+CSGrid()\ImgHeight)
    tCol = -1
    tRow = -1
    ActCol = CSGrid()\ScrollX
    ActRow = CSGrid()\ScrollY
    ;Debug GadgetX(CSGrid()\hGadget)
    ;Debug GadgetY(CSGrid()\hGadget)
    ActX = tleft
    ActY = ttop
    Select tmode
      Case 0
        tEvent = #CSGRID_Event_CellSelect
      Case 1
        tEvent = 65
      Case 2
        tEvent = 66
    EndSelect
    If CSGrid()\RowCaptVisible = 1
      ActX + CSGrid()\RowCaptWidth
    EndIf          
    If CSGrid()\ColCaptVisible = 1
      ActY + CSGrid()\DefGridHeight
    EndIf
    While ActCol < CSGrid()\Cols And ActX < (CSGrid()\ImgWidth+tleft) And ActX < mPosX
      ActWidth.w = H_GetColWidth(ActCol.b)
      ;Debug "ActX:"+Str(ActX)+"  End:"+Str((ActX+ActWidth))
      If CSGrid()\ColCaptVisible = 1 And ((CSGrid()\ColCustWidth = 1 And mPosY <= ActY And mPosX >= ActX-2 And mPosX <= ActX+2) Or CSGrid()\ColCustWidth > 1)
        ; Spaltenbreite anpassen
        If CSGrid()\ColCustWidth = 1
          CSGrid()\ColCustWidth = ActCol + 9 ; Feld wird als Merker fr die Spalten-Nummer missbraucht
          ;Debug "START SIZING"
          H_DisableAlleDetailObjects()
          Break
        Else
          If ActCol = CSGrid()\ColCustWidth-10 And tMode = 2
            H_SetColWidth(CSGrid()\hGadget,ActCol,(mPosX-ActX))
            CSGrid()\ColCustWidth = 1
            ;Debug "END SIZING"
            Break
          EndIf
        EndIf
      Else
        If mPosX >= ActX  And mPosX <= (ActX+ActWidth)
          tCol = ActCol
          Break
        EndIf
      EndIf
      ActCol+1        
      ActX+ActWidth
    Wend
    If CSGrid()\ColCustWidth <= 1
      If tCol = -1
        If mPosX > ActX
          tCol = -2
        EndIf
      EndIf
      While ActRow < CSGrid()\Rows And ActY < CSGrid()\ImgHeight+ttop And ActY < mPosY
        theight = H_GetRowHeight(ActRow)
        ;Debug "ActY:"+Str(ActY)+"  End:"+Str((ActY+CSGrid()\DefGridHeight))
        If mPosY >= ActY And mPosY <= (ActY+theight)
          tRow = ActRow
          ;Break
        EndIf
        If CSGrid()\RowExpand = 1 And CSGrid()\RowCaptVisible = 1 
          If H_GetRowDetailsHandle(ActRow) <> 0
            If tRow = ActRow And mPosX >= CSGrid()\Left And mPosX < (CSGrid()\Left + CSGrid()\RowCaptWidth) And tMode = 2 
              If CSGrid_Row()\DetailsVisible = -1
                tEvent = H_EnableDetailsObject(-1)
              Else
                tEvent = H_DisableDetailsObject(-1,1)
              EndIf
            EndIf
          EndIf
        EndIf
        If tRow = ActRow Or tRow = -3
          Break
        EndIf
        ActRow+1      
        ActY+theight
      Wend
      If tRow = -1
        If mPosY > ActY
          tRow = -2          
        EndIf
      EndIf
      If H_GetCellLockStatus(tCol,tRow) <= -16
        If tCol > CSGrid()\ActColStart
          tCol + 1
        EndIf
        If tRow > CSGrid()\ActRowStart
          tRow + 1
        EndIf
      EndIf
      H_SetCursor(tMode.b,tCol.b,tRow.w)
    EndIf
  EndIf
  ProcedureReturn tEvent
EndProcedure


Procedure.b H_SortColbyMouse()
  ; Hilfsfunktion zum Sortieren einer Spalte mittels Maus, sofern zugelassen
  Protected tdone.b
  tdone = -1
  Protected mPosX.w, mPosY.w, ActCol.b, ActWidth.w, ActX.w,tleft.w,ttop.w
  If CSGrid()\UserSort = 1
    mPosX = WindowMouseX(WindowID) 
    mPosY = WindowMouseY(WindowID)
    If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1
      tleft = CSGrid()\LeftAbs
      ttop = CSGrid()\TopAbs 
    Else
      tleft = CSGrid()\Left
      ttop = CSGrid()\Top
    EndIf
    ;Debug "mPosX:"+Str(mPosX)+"  tleft:"+Str(tleft)+"   mPosY:"+Str(mPosY)+"   ttop:"+Str(ttop)
    If mPosX >=tleft And mPosX <= (tleft+CSGrid()\ImgWidth) And mPosY >= ttop And mPosY <= (ttop+CSGrid()\DefGridHeight)
      ActCol = CSGrid()\ScrollX
      ActX = tleft
      If CSGrid()\RowCaptVisible = 1
        ActX + CSGrid()\RowCaptWidth
      EndIf          
      While ActCol < CSGrid()\Cols And ActX < (CSGrid()\ImgWidth+tleft) And ActX < mPosX
        ActWidth.w = H_GetColWidth(ActCol.b)
        ;Debug "mPosX:"+Str(mPosX)+"   ActX:"+Str(ActX)
        ;If mPosX >= (ActX+ActWidth-CSGrid()\DefGridHeight) And mPosX <= (ActX+ActWidth-2)
        If mPosX >= ActX And mPosX <= (ActX+ActWidth)
          ;Debug "CSGrid()\SortCol:"+Str(CSGrid()\SortCol)+"    ActCol:"+Str(ActCol)
          If CSGrid()\SortCol = ActCol
            CSGrid()\SortDir * -1
          Else
            CSGrid()\SortCol = ActCol
          EndIf
          tdone = 1
          ;Debug "CSGrid()\SortDir:"+Str(CSGrid()\SortDir)
          H_DoColSorting(ActCol,CSGrid()\SortDir)
          Break
        EndIf
        ActCol+1   
        ActX+ActWidth        
      Wend
    EndIf  
  EndIf
  ProcedureReturn tdone
EndProcedure


Procedure H_SetCursor(tMode.b,tCol.b,tRow.w)
  ; Hilfsfunktion zum Setzen des aktuellen Cursors (-1=ganze Spalte/Zeile)
  ; tMode 0 = Start/End-Position setzen
  ; tMode 1 = Nur Start-Position setzen
  ; tMode 2 = Nur End-Position setzen  
  Protected OldScrollX.b, OldScrollY.w
  If tRow = -3
    ;H_DrawDetails(-1)
  Else
    If tCol > -2 And tRow > -2 And tCol < CSGrid()\Cols And tRow < CSGrid()\Rows
      If (tRow <> CSGrid()\ActRowEnd Or tCol <> CSGrid()\ActColEnd) And tCol > -1
        H_DisableAlleDetailObjects()
      EndIf
      
      If CSGrid()\InputMode > 0
        H_CellInput(-1)
      EndIf  
      If tCol >= 0 And (tCol < CSGrid()\ScrollX Or tCol >= CSGrid()\LastVisCol) And tCol <> CSGrid()\ActColEnd
        OldScrollX = CSGrid()\ScrollX
        If tCol >= CSGrid()\LastVisCol
          CSGrid()\ScrollX = tCol - (CSGrid()\LastVisCol - CSGrid()\ScrollX - 1)
        Else
          CSGrid()\ScrollX = tCol
        EndIf
        If CSGrid()\ScrollX < 0
          CSGrid()\ScrollX = 0
        EndIf
      EndIf     
      If tRow >= 0 And (tRow < CSGrid()\ScrollY Or tRow > CSGrid()\LastVisRow) And tRow <> CSGrid()\ActRowEnd
        OldScrollY = CSGrid()\ScrollY
        If tRow > CSGrid()\LastVisRow
          CSGrid()\ScrollY = tRow - (CSGrid()\LastVisRow - CSGrid()\ScrollY - 1)
        Else
          CSGrid()\ScrollY = tRow
        EndIf
        If CSGrid()\ScrollY < 0
          CSGrid()\ScrollY = 0
        EndIf
      EndIf
      If OldScrollX <> CSGrid()\ScrollX Or OldScrollY <> CSGrid()\ScrollY
        H_DrawScrollbars(-1)
      EndIf
      Select tMode
        Case 0 ; Start/End-Position setzen
          If tCol > -1
            CSGrid()\ActColStart = tCol
            CSGrid()\ActColEnd = tCol
          Else
            CSGrid()\ActColStart = 0
            CSGrid()\ActColEnd = CSGrid()\Cols-1
          EndIf
          If tRow > -1
            CSGrid()\ActRowStart = tRow
            CSGrid()\ActRowEnd = tRow
          Else
            CSGrid()\ActRowStart = 0
            CSGrid()\ActRowEnd = CSGrid()\Rows-1
          EndIf
        Case 1 ; Start-Position setzen
          If tCol > -1
            CSGrid()\ActColStart = tCol
          Else
            CSGrid()\ActColStart = 0
          EndIf
          If tRow > -1
            CSGrid()\ActRowStart = tRow
          Else
            CSGrid()\ActRowStart = 0
          EndIf
        Case 2 ; End-Position setzen
          If tCol > -1
            CSGrid()\ActColEnd = tCol
          Else
            CSGrid()\ActColEnd = CSGrid()\Cols-1
          EndIf
          If tRow > -1
            CSGrid()\ActRowEnd = tRow
          Else
            CSGrid()\ActRowEnd = CSGrid()\Rows-1
          EndIf
      EndSelect
      If CSGrid()\ActColEnd < CSGrid()\ActColStart
        tCol = CSGrid()\ActColEnd
        CSGrid()\ActColEnd = CSGrid()\ActColStart
        CSGrid()\ActColStart = tCol
      EndIf
      If CSGrid()\ActRowEnd < CSGrid()\ActRowStart
        tRow = CSGrid()\ActRowEnd
        CSGrid()\ActRowEnd = CSGrid()\ActRowStart
        CSGrid()\ActRowStart = tRow
      EndIf
      H_DrawGrid(-1)
    EndIf
  EndIf
EndProcedure


Procedure H_MouseInput(tEventType)
  ; Hilfsfunktion zum Ermitteln der Mausaktivitt bei der Eingabe
  Protected mPosX.w, mPosY.w, ActCol.b, ActWidth.w, ActRow.w, ActX.w, ActY.w, y.b, tInp.b, tHeight.w,tlsize.b,tleft.w,ttop.w
  mPosX = WindowMouseX(WindowID) 
  mPosY = WindowMouseY(WindowID)
  If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1
    tleft = CSGrid()\LeftAbs
    ttop = CSGrid()\TopAbs 
  Else
    tleft = CSGrid()\Left
    ttop = CSGrid()\Top
  EndIf
  If mPosX >=tleft And mPosX <= (tleft+CSGrid()\ImgWidth) And mPosY >= ttop And mPosY <= (ttop+CSGrid()\ImgHeight)
    ActCol = CSGrid()\ScrollX
    ActRow = CSGrid()\ScrollY
    ActX = tleft
    ActY = ttop
    tInp = H_GetColInputType(CSGrid()\ActColEnd)
    tHeight = GadgetHeight(CSGrid()\hInput)
    If CSGrid()\RowCaptVisible = 1
      ActX + CSGrid()\RowCaptWidth
    EndIf          
    If CSGrid()\ColCaptVisible = 1
      ActY + CSGrid()\DefGridHeight
    EndIf
    While ActCol < CSGrid()\Cols And ActX < (CSGrid()\ImgWidth+tleft) And ActX < mPosX And ActCol < CSGrid()\ActColEnd
      ActWidth.w = H_GetColWidth(ActCol.b)
      ActCol+1        
      ActX+ActWidth
    Wend
    ActWidth.w = H_GetColWidth(ActCol.b)    
    While ActRow < CSGrid()\Rows And ActY < CSGrid()\ImgHeight And ActY < mPosY And ActRow < CSGrid()\ActRowEnd
      ActY+H_GetRowHeight(ActRow);CSGrid()\DefGridHeight
      ActRow+1      
    Wend
    If mPosX >= ActX And mPosX <= (ActX+ActWidth) And mPosY >= ActY And mPosY <= (ActY+tHeight)
      ; Maus ist innerhalb des Eingabe-Objektes
      If tInp > 31 ; Drop-Down
        If CountGadgetItems(CSGrid()\hInput) < 5
          tHeight = CountGadgetItems(CSGrid()\hInput)
        Else
          tHeight = 5
        EndIf
        tlsize = Int(GadgetHeight(CSGrid()\hInput) / tHeight)          
        For y = 0 To tHeight
          If mPosY >= (ActY+(tlsize*y)) And mPosY <= (ActY+(tlsize*(y+1)))
            SetGadgetState(CSGrid()\hInput,y)            
            If tEventType = #PB_EventType_LeftDoubleClick
              H_CellInput(0)
            EndIf
            Break
          EndIf
        Next
      EndIf
    EndIf
  EndIf
EndProcedure


Procedure.b H_CellInput(tMode.b)
  ; Hilfsfunktion um das Eingabefeld bei der Zell-Eingabe anzuzeigen
  Protected twidth.w,theight.b,tval.l,tleft.w,ttop.w,ttext.s, resp.b
  resp = 1
  If H_GetColDataType(CSGrid()\ActColEnd) = 2
    ; Boolean
    If H_GetCellLockStatus(CSGrid()\ActColEnd,CSGrid()\ActRowEnd) >= 0 And CSGrid()\GridLock = 0
      tval = Val(H_GetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd))
      If tval <> 1
        tval = -1
      EndIf
      tval * -1
      H_SetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd,Str(tval))
      resp = 1
    EndIf
  Else
    If tMode <= 0 And CSGrid()\InputMode > 0
      H_InitShortCuts()
      CSGrid()\InputMode = 0
      If CSGrid()\hInput <> 0
        If tMode = 0
          If H_CheckIfColSetExists(CSGrid()\ActColEnd) > -1
            Select CSGrid_Col()\inputType
              Case 17,19
                ttext = Str(GetGadgetState(CSGrid()\hInput))
              Default
                ttext = GetGadgetText(CSGrid()\hInput)
            EndSelect
          Else
            ttext = GetGadgetText(CSGrid()\hInput)
          EndIf
          If H_GetColDataType(CSGrid()\ActColEnd) > 2 And CSGrid()\CommaSep = 0 ; Deutsche Nummern-Eingabe
            ttext = ReplaceString(ttext,".","")
            ttext = ReplaceString(ttext,",",".")            
          EndIf
          H_SetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd,ttext)
          If CSGrid()\AutoSort > -1 And CSGrid()\ActColEnd = CSGrid()\SortCol
            H_DoColSorting(CSGrid()\SortCol,CSGrid()\SortDir)
            H_DrawGrid(-1)
          EndIf
        EndIf
        If IsGadget(CSGrid()\hInput)
          FreeGadget(CSGrid()\hInput)
        EndIf
        CSGrid()\hInput = 0
        resp = 1
      EndIf
    EndIf
    If tMode > 0
      If H_GetCellLockStatus(CSGrid()\ActColEnd,CSGrid()\ActRowEnd) >= 0 And CSGrid()\GridLock = 0 And CSGrid_Col()\datatype <> 4
        H_RemoveShortCuts(1)  
        CSGrid()\InputMode = tMode
        twidth.w = (H_GetColWidth(CSGrid()\ActColEnd)-1)
        If (CSGrid()\Left+2+CSGrid()\ActXEnd+twidth.w) > (CSGrid()\left+CSGrid()\ImgWidth)
          twidth.w = (CSGrid()\left+CSGrid()\ImgWidth) - (CSGrid()\Left+CSGrid()\ActXEnd)
        EndIf

        theight.b = (H_GetRowHeight(CSGrid()\ActRowEnd)-1)
        If (CSGrid()\Top+2+CSGrid()\ActYEnd+theight.b) > (CSGrid()\Top+CSGrid()\ImgHeight)
          theight.b = (CSGrid()\top+CSGrid()\ImgHeight) - (CSGrid()\Top+CSGrid()\ActYEnd)
        EndIf
        
        ;OpenGadgetList(CSGrid()\hGadget)
          If CSGrid()\LeftAbs > -1 And CSGrid()\TopAbs > -1
            tleft = CSGrid()\LeftAbs+4
            ttop = CSGrid()\TopAbs+4
          Else
            tleft = CSGrid()\Left+2
            ttop = CSGrid()\Top+2
          EndIf
          ttext = H_GetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd)
          If H_GetColDataType(CSGrid()\ActColEnd) > 2 And CSGrid()\CommaSep = 0 ; Deutsche Nummern-Eingabe
            ttext = ReplaceString(ttext,".",",")
          EndIf                    
          If H_CheckIfColSetExists(CSGrid()\ActColEnd) > -1
            If CSGrid_Col()\inputType > 31 And CSGrid_Col()\inputRessource <> "" ; Rollup
              Select CSGrid_Col()\inputType
                Case 34 ; Combo mit Werteliste
                  CSGrid()\hInput = ComboBoxGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,200, #PB_ComboBox_Editable)                                
                  ;CSGrid()\hInput = ComboBoxGadget(#PB_Any,tleft+CSGrid()\ActXEnd,0,twidth,200, #PB_ComboBox_Editable)                                
                  SetGadgetText(CSGrid()\hInput,ttext)
                Default
                  CSGrid()\hInput = ListViewGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,(CSGrid()\DefGridHeight*4)-1)
              EndSelect
              H_CreateSelListEntries(CSGrid_Col()\inputRessource,CSGrid_Col()\inputType,H_GetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd))
              If CountGadgetItems(CSGrid()\hInput) < 5 And CSGrid_Col()\inputType <> 34
                ResizeGadget(CSGrid()\hInput,#PB_Ignore,#PB_Ignore,#PB_Ignore,(CSGrid()\DefGridHeight*(CountGadgetItems(CSGrid()\hInput)-1))-1)
              EndIf
            Else 
              Select CSGrid_Col()\inputType
                Case 16 ; Spin
                  CSGrid()\hInput = SpinGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight,CSGrid_Col()\inputValueMin,CSGrid_Col()\inputValueMax,#PB_Spin_Numeric)
                  SetGadgetState(CSGrid()\hInput,Val(ttext))
                  SetGadgetText(CSGrid()\hInput,ttext)
                Case 17 ; Datepicker
                  CSGrid()\hInput = DateGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight)
                  If CSGrid_Col()\inputValueMin > 0
                    SetGadgetAttribute(CSGrid()\hInput,#PB_Date_Minimum,CSGrid_Col()\inputValueMin)
                  EndIf
                  If CSGrid_Col()\inputValueMax > 0
                    SetGadgetAttribute(CSGrid()\hInput,#PB_Date_Minimum,CSGrid_Col()\inputValueMax)
                  EndIf                
                  SetGadgetState(CSGrid()\hInput,Val(ttext))
                Case 18 ; IP-Address
                  CSGrid()\hInput = IPAddressGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight)
                  tval1.b = Val(Mid(ttext,1,3))
                  tval2.b = Val(Mid(ttext,5,3))
                  tval3.b = Val(Mid(ttext,9,3))
                  tval4.b = Val(Mid(ttext,13,3))
                  SetGadgetState(CSGrid()\hInput,MakeIPAddress(tval1,tval2,tval3,tval4))
                Case 19 ; Trackbar
                  CSGrid()\hInput = TrackBarGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight,CSGrid_Col()\inputValueMin,CSGrid_Col()\inputValueMax,1)
                  SetGadgetState(CSGrid()\hInput,Val(ttext))
                Default
                  CSGrid()\hInput = StringGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight,ttext)
                  ;CSGrid()\hInput = StringGadget(#PB_Any,CSGrid()\ActXEnd,CSGrid()\ActYEnd,twidth,theight,H_GetCellValue(CSGrid()\ActColEnd,CSGrid()\ActRowEnd))              
              EndSelect          
            EndIf
          Else
            CSGrid()\hInput = StringGadget(#PB_Any,tleft+CSGrid()\ActXEnd,ttop+CSGrid()\ActYEnd,twidth,theight,ttext)
          EndIf
        ;CloseGadgetList()
        SetActiveGadget(CSGrid()\hInput)
        resp = 1
      Else
        resp = 0
      EndIf
    Else
      FreeGadget(CSGrid()\hInput)
      CSGrid()\hInput = 0
    EndIf
  EndIf
  ProcedureReturn resp
EndProcedure


Procedure H_InitShortCuts()
  ; Hilfsfunktion zum Setzen der Tastatur-Shortcuts zur Steuerung des Grid-Controls
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Return, #EventID_Return)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Escape)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Left, #EventID_Left)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Up, #EventID_Up)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Right, #EventID_Right)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Down, #EventID_Down)     
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Left, #EventID_SLeft)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Up, #EventID_SUp)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Right, #EventID_SRight)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Down, #EventID_SDown)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Space, #EventID_Space)
  AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Escape, #EventID_ESC)
EndProcedure


Procedure H_RemoveShortCuts(tMode.b)
  ; Hilfsfunktion zum Entfernen der Tastatur-Shortcuts zur Steuerung des Grid-Controls
  If tMode = 1
    AddKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Escape, #EventID_ESC)
  Else
    RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Escape)
    RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Return)
  EndIf
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Left)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Up)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Right)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Down)     
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Left)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Up)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Right)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Shift | #PB_Shortcut_Down)
  RemoveKeyboardShortcut(CSGrid_WindowID, #PB_Shortcut_Space)
EndProcedure


Procedure.b H_GetGadget(Gadget.l)
  ; Hilfsfunktion zum Ermitteln des aktuellen Gadget-Info-Sets
  Protected tstat.b
  tstat = -1
  ResetList(CSGrid())
  While NextElement(CSGrid())
    ;Debug "hGadget:"+Str(CSGrid()\hGadget)+"  GADGET:"+Str(Gadget.l)
    If CSGrid()\hGadget = Gadget.l
      tstat = 1
      Break
    EndIf
  Wend
  ProcedureReturn tstat
EndProcedure


Procedure H_GetCol(Gadget.l,Col.b)
  ; Hilfsfunktion zum Auswhlen der Spalte-Informationen, wenn nicht vorhanden wird diese angelegt
  If H_CheckIfColSetExists(Col.b) < 1
    LastElement(CSGrid_Col())
    AddElement(CSGrid_Col())
    CSGrid_Col()\hGadget = Gadget.l
    CSGrid_Col()\col = Col.b
  EndIf  
EndProcedure


Procedure H_SetColWidth(Gadget.l,Col.b,Width.w)
  ; Hilfsfunktion zum Setzen der Spaltenbreite
  H_GetCol(Gadget.l,Col.b)
  CSGrid_Col()\width = width.w
  H_DrawGrid(-1)
EndProcedure


Procedure.w H_GetColWidth(Col.b)
  ; Hilfsfunktion zum Ermitteln der Spaltenbreite
  Protected twidth.w
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      twidth.w = CSGrid_Col()\width
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          twidth.w = CSGrid_Col()\width
          Break
        EndIf
      Wend
    EndIf
  EndIf
  If twidth.w = 0
    twidth.w = CSGrid()\DefGridWidth
  EndIf
  If twidth.w = -1
    twidth.w = 0
  EndIf
  ProcedureReturn twidth
EndProcedure


Procedure H_SetColDataType(Gadget.l,Col.b,DataType.b)
  ; Hilfsfunktion zum Setzen des Datentyps einer Spalte
  H_GetCol(Gadget.l,Col.b)
  CSGrid_Col()\datatype = DataType.b
  H_DrawGrid(-1)
EndProcedure


Procedure.b H_GetColDataType(Col.b)
  ; Hilfsfunktion zum Ermitteln des Datentyps einer Spalte
  Protected tdattyp.b
  tdattyp.b = 0
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      tdattyp.b = CSGrid_Col()\datatype
    Else  
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          tdattyp.b = CSGrid_Col()\datatype
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn tdattyp
EndProcedure


Procedure H_SetColUserNumberFormat(Gadget.l,Col.b,userNumberFormat.s)
  ; Hilfsfunktion zum Setzen des benutzerdefinierten Zahlenformats
  H_GetCol(Gadget.l,Col.b)
  CSGrid_Col()\userNumberFormat = userNumberFormat.s
  ;CSGrid_Col()\datatype = #CSGRID_DataType_User ; Nicht mehr pauschal mglich, wegen Dateformat
  H_DrawGrid(-1)
EndProcedure


Procedure.s H_GetColUserNumberFormat(Col.b)
  ; Hilfsfunktion zum Ermitteln des benutzerdefinierten Zahlenformats
  Protected UserNumFormat.s
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      UserNumFormat.s = CSGrid_Col()\userNumberFormat
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          UserNumFormat.s = CSGrid_Col()\userNumberFormat
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn UserNumFormat
EndProcedure


Procedure.b H_GetColInputType(Col.b)
  ; Hilfsfunktion zum Ermitteln des Eingabe-Types
  Protected inputRessource.s
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      inputType.b = CSGrid_Col()\inputType
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          inputType.b = CSGrid_Col()\inputType
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn inputType
EndProcedure


Procedure.s H_GetColInputRessource(Col.b)
  ; Hilfsfunktion zum Ermitteln der Eingabe-Ressource
  Protected inputRessource.s
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      inputRessource.s = CSGrid_Col()\inputRessource
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          inputRessource.s = CSGrid_Col()\inputRessource
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn inputRessource
EndProcedure


Procedure H_SetColSummaryFlag(Gadget.l,Col.b,Summary.b)
  ; Hilfsfunktion zum Setzen der Spalten-Summen-Eigenschaft
  H_GetCol(Gadget.l,Col.b)
  CSGrid_Col()\summary = Summary.b
  CSGrid()\ShowColSummary = 0
  ResetList(CSGrid_Col())
  While NextElement(CSGrid_Col())
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      CSGrid()\ShowColSummary = 1
      Break
    EndIf
  Wend
  H_DrawGrid(-1)
EndProcedure


Procedure.b H_GetColSummaryFlag(Col.b)
  ; Hilfsfunktion zum Ermitteln der Spalten-Summen-Eigenschaft
  Protected tdattyp.b
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      summary.b = CSGrid_Col()\summary
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          summary.b = CSGrid_Col()\summary
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn summary
EndProcedure


Procedure.s H_GetColCaption(Col.b)
  ; Hilfsfunktion zum Ermitteln der Spaltenbeschriftung
  Protected tcapt.s
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      tcapt.s = CSGrid_Col()\caption
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          tcapt.s = CSGrid_Col()\caption
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn tcapt
EndProcedure


Procedure.b H_GetColCaptOrient(Col.b)
  ; Hilfsfunktion zum Ermitteln der Spaltenbeschriftungs-Ausrichtung
  Protected torient.b
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      torient = CSGrid_Col()\captorient
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          torient = CSGrid_Col()\captorient
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn torient  
EndProcedure


Procedure.l H_GetColColorBack(Col.b)
  ; Hilfsfunktion zum Ermitteln der Spalten-Hintergrundfarbe
  Protected colorback.l
  If CountList(CSGrid_Col()) > 0
    If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
      colorback = CSGrid_Col()\colorBack
    Else
      ResetList(CSGrid_Col())
      While NextElement(CSGrid_Col())
        If CSGrid_Col()\col = Col.b And CSGrid_Col()\hGadget = CSGrid()\hGadget
          colorback = CSGrid_Col()\colorBack
          Break
        EndIf
      Wend
    EndIf
  EndIf
  If colorback = 0
    colorback = CSGrid()\Color_CellBack
  EndIf
  ProcedureReturn colorback
EndProcedure


Procedure.s H_GetRowCaption(Row.w)
  ; Hilfsfunktion zum Ermitteln der Zeilenbeschriftung
  Protected tcapt.s
  If CountList(CSGrid_Row()) > 0
    If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
      tcapt.s = CSGrid_Row()\caption
    Else
      ResetList(CSGrid_Row())
      While NextElement(CSGrid_Row())
        If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
          tcapt.s = CSGrid_Row()\caption
          Break
        EndIf
      Wend
    EndIf
  EndIf
  If tcapt.s = ""
    tcapt.s = Str(Row.w+1)
  EndIf
  ProcedureReturn tcapt
EndProcedure


Procedure.b H_GetRowHeight(Row.w)
  ; Hilfsfunktion zum Ermitteln der Zeilenhhe
  Protected theight.b
  If CountList(CSGrid_Row()) > 0
    If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
      theight = CSGrid_Row()\height
    Else
      ResetList(CSGrid_Row())
      While NextElement(CSGrid_Row())
        If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
          theight = CSGrid_Row()\height
          Break
        EndIf
      Wend
    EndIf
  EndIf
  If theight <= 0
    theight = CSGrid()\DefGridHeight
  EndIf
  ProcedureReturn theight
EndProcedure


Procedure.l H_GetRowDetailsHandle(Row.w)
  ; Hilfsfunktion zum Ermitteln des Objektes fr die Zeilen-Details-Darstellung
  Protected handle.l
  If CountList(CSGrid_Row()) > 0
    If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
      handle.l = CSGrid_Row()\hDetails
    Else
      ResetList(CSGrid_Row())
      While NextElement(CSGrid_Row())
        If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
          handle.l = CSGrid_Row()\hDetails
          Break
        EndIf
      Wend
    EndIf
  EndIf
  ProcedureReturn handle
EndProcedure


Procedure.l H_GetRowColorBack(Row.w)
  ; Hilfsfunktion zum Ermitteln der Hintergrundfarbe der Zeile
  Protected colorBack.l
  If CountList(CSGrid_Row()) > 0
    If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
      colorBack.l = CSGrid_Row()\colorBack
    Else
      ResetList(CSGrid_Row())
      While NextElement(CSGrid_Row())
        If CSGrid_Row()\row = Row.w And CSGrid_Row()\hGadget = CSGrid()\hGadget
          colorBack.l = CSGrid_Row()\colorBack
          Break
        EndIf
      Wend
    EndIf
  EndIf
  If colorback = 0
    colorback = CSGrid()\Color_CellBack
  EndIf  
  ProcedureReturn colorBack
EndProcedure


Procedure.l H_GetCellColorBack(Col.b,Row.b)
  ; Hilfsfunktion zur Ermittlung der Zellen-Hintergrundfarbe
  Protected color.l
  color = H_GetColColorBack(Col)
  If color = CSGrid()\Color_CellBack
    color = H_GetRowColorBack(Row)
  EndIf
  ProcedureReturn color
EndProcedure


Procedure.l H_GetCell(Col.b,Row.w)
  ; Hilfsfunktion zum Indizieren einer Zelle im Infoset
  Protected tcell.l
  tcell.l = (CSGrid()\Cols * Row.w) + Col.b + CSGrid()\CellMatrixStartID
  If tCell.l >= 0
    SelectElement(CSGrid_Cell(),tcell.l)
    ProcedureReturn tcell
  Else
    ProcedureReturn -1
  EndIf
EndProcedure    


Procedure.s H_GetCellValue(Col.b,Row.w)
  ; Hilfsfunktion zum Ermitteln des Zell-Inhalts
  If H_GetCell(Col.b,Row.w) >= 0
    ProcedureReturn CSGrid_Cell()\content
  EndIf
EndProcedure


Procedure.b H_GetCellLockStatus(Col.b,Row.w)
  ; Hilfsfunktion zum Ermitteln des Sperr-Zustandes einer Zelle
  If H_GetCell(Col.b,Row.w) >= 0
    ProcedureReturn CSGrid_Cell()\lock  
  EndIf
EndProcedure


Procedure H_SetCellValue(Col.b,Row.w,Value.s)
  ; Hilfsfunktion zum Setzen des Zell-Inhalts
  If H_GetCell(Col.b,Row.w) >= 0
    CSGrid_Cell()\content = Value.s
    H_DrawGrid(-1)  
  EndIf
EndProcedure


Procedure.b H_GetFocusedGrid()
  ; Hilfsfunktion zum Ermitteln des fokusierten Grids
  Protected mPosX.w, mPosY.w,tsuc.b,tredraw.b
  tsuc = -1
  mPosX = WindowMouseX(WindowID)
  mPosY = WindowMouseY(WindowID)

  ; Z-Order-Problem: Die lteren Gadgets haben Vorrang bei den Events
  ResetList(CSGrid())
  While NextElement(CSGrid())  
    ;Debug "GAD:" + Str(CSGrid()\hGadget) + "  HID:" + Str(CSGrid()\Hidden)
    If CSGrid()\Hidden < 1
      If mPosX >= CSGrid()\left And mPosX <= (CSGrid()\left+CSGrid()\width) And mPosY >= CSGrid()\top And mPosY <= (CSGrid()\top+CSGrid()\height)
        If CSGrid_ActGridhGadget.l <> CSGrid()\hGadget
          tredraw.b = 1
        EndIf
        CSGrid_ActGridhGadget.l = CSGrid()\hGadget
        tsuc = 1
        ;Break
      EndIf
    EndIf
  Wend
  If tredraw.b = 1
    ResetList(CSGrid())
    While NextElement(CSGrid())
      H_DrawGrid(-1)
    Wend
    H_GetGadget(CSGrid_ActGridhGadget.l)
  EndIf
  ;Debug CSGrid_ActGridhGadget
  ProcedureReturn tsuc
EndProcedure


Procedure H_DrawCellContent(tText.s,tx.w,ty.w,twidth.w,tType.b,tOrient.b=-1,theight.w=0)
  ; Hilfsfunktion zum Zeichnen des Zellinhaltes
  Protected scale.f
  Select tType.b
    Case 2 ; Boolean
      H_DrawBooleanValue(tx,ty,twidth,Val(tText.s))
    Case 4 ; Picture
      If Val(tText.s) <> 0
        If IsImage(Val(tText.s))          
          If twidth-4 > ImageWidth((Val(tText.s)))
            scale = 1
          Else
            scale = (twidth-4) / ImageWidth(Val(tText.s))
          EndIf
          If scale > ((theight-4) / ImageHeight(Val(tText.s)))
            scale = (theight-4) / ImageHeight(Val(tText.s))
          EndIf
          CompilerIf #PB_Compiler_OS = #PB_OS_Windows
            DrawImage(ImageID(Val(tText.s)),tx,ty,ImageWidth(Val(tText.s))*scale,ImageHeight(Val(tText.s))*scale)
          CompilerEndIf
        Else
          DrawText(tx.w,ty.w,"no img")
        EndIf
      EndIf
    Default
      If tType.b > 0 Or tOrient > 0
        tText.s = H_FormatCell(tText.s,tType.b)      
        If tType.b = 2 Or tOrient = 2
          ; zentriert
          While twidth < TextWidth(tText)
            tText = Left(tText,Len(tText)-1)
          Wend
          tx.w = tx.w + ((twidth.w - TextWidth(tText.s) - 4) / 2)
        Else
          If tOrient = -1 Or tOrient = 1
            ; recht bndig
            While twidth < TextWidth(tText)
              tText = Right(tText,Len(tText)-1)
            Wend        
            tx.w = tx.w + twidth.w - TextWidth(tText.s) - 4
          EndIf
        EndIf
      Else
        ; links bndig
        While twidth < TextWidth(tText)
          tText = Left(tText,Len(tText)-1)
        Wend        
      EndIf
      DrawText(tx.w,ty.w,tText.s)    
  EndSelect
EndProcedure


Procedure.s H_FormatCell(tText.s,tType.b)
  ; Hilfsfunktion zum Formatieren des Zell-Inhalts
  ; 0=Text, 1=Ganzzahl, 2=Boolean, 16=Fliekomma, 17=Fliekomma (2 Stellen), 32=EUR, 33=USD, 64=Prozent, 127=benutzerdefiniertes Ausgabeformat
  If tText.s <> ""
    Select tType.b
      Case #CSGRID_DataType_Int ; Ganzzahl
        tText.s = Str(Val(tText.s))
      Case #CSGRID_DataType_Bool ; Boolean
        If Val(tText.s) > 0
          tText.s = "X"
        Else
          tText.s = ""
        EndIf
      Case #CSGRID_DataType_Date ; Date/Time
        tText.s = FormatDate(CSGrid_Col()\userNumberFormat,Val(tText.s))
      Case #CSGRID_DataType_Float ; Fliekomma
        If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
          tText.s = H_FormatNumberString("###,###,##0.########",ValF(tText.s))
        Else
          tText.s = H_FormatNumberString("###.###.##0,########",ValF(tText.s))
        EndIf
        ;tText.s = Str(ValF(tText.s))
      Case #CSGRID_DataType_F2Dig ; Fliekomma (2 Stellen)
        If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
          tText.s = H_FormatNumberString("###,###,##0.0~",ValF(tText.s))
        Else
          tText.s = H_FormatNumberString("###.###.##0,0~",ValF(tText.s))
        EndIf
      Case #CSGRID_DataType_EUR ; EUR
        If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
          tText.s = H_FormatNumberString("###,###,##0.0~ EUR",ValF(tText.s))
        Else
          tText.s = H_FormatNumberString("###.###.##0,0~ EUR",ValF(tText.s))
        EndIf
      Case #CSGRID_DataType_USD ; USD
        If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
          tText.s = H_FormatNumberString("###,###,##0.0~ USD",ValF(tText.s))
        Else
          tText.s = H_FormatNumberString("###.###.##0,0~ USD",ValF(tText.s))
        EndIf          
      Case #CSGRID_DataType_Percent ; Prozent
        If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
          tText.s = H_FormatNumberString("###,##0.000~ %",(ValF(tText.s) * 100))
        Else
          tText.s = H_FormatNumberString("###.##0,000~ %",(ValF(tText.s) * 100))
        EndIf
      Case #CSGRID_DataType_User ; benutzerdefiniertes Zahlenformat
        tText.s = H_FormatNumberString(CSGrid_Col()\userNumberFormat,ValF(tText.s))
    EndSelect
  EndIf
  ProcedureReturn tText
EndProcedure


Procedure.s H_FormatNumberString(Format.s,Number.f) 
  ; Hilfsfunktion zum Formatieren einer Zahl
  ; 0 = Ziffer/Vorzeichen oder zwingend 0 
  ; # = Ziffer/Vorzeichen oder Blank
  ; , = Trennung fr Nachkomma-Stellen
  ; andere Zeichen werden 1:1 ausgegeben       
  Protected Result.s, tPos.w, tFormatL.s, tFormatR.s, tWertL.s, tWertR.s, tcomma.s,tmsep.s
  Result.s = StrF(Number.f)
  If Len(Format.s) > 0
    If CSGrid()\CommaSep = -81 ; wenn Separator ein Punkt ist
      tcomma.s = "."
      tmsep.s = ","
    Else
      tcomma.s = ","
      tmsep.s = "."
    EndIf
    tPos.w = FindString(Format.s,tcomma.s,1)
    If tPos.w > 0
      tFormatL.s = Left(Format.s,tPos.w-1)
      tFormatR.s = Right(Format.s,Len(Format.s)-tPos.w)
      tPos.w = FindString(Result.s,".",1)
      If tPos.w > 0
        tWertL.s = Left(Result.s,tPos.w-1)
        tWertR.s = Right(Result.s,Len(Result.s)-tPos.w)
      EndIf
    Else
      tFormatL.s = Format.s
      tWertL.s = Result.s
    EndIf
    Result.s = ""
    For tPos.w = Len(tFormatL.s) To 1 Step -1 
      Select Mid(tFormatL.s,tPos.w,1) 
        Case "0" 
          If Len(tWertL.s) 
            Result.s = Right(tWertL.s,1) + Result.s 
            tWertL.s = Left(tWertL.s,Len(tWertL.s)-1) 
          Else 
            Result.s = "0" + Result.s 
          EndIf 
        Case "#" 
          If Len(tWertL.s)  
            Result.s = Right(tWertL.s,1) + Result.s 
            tWertL.s = Left(tWertL.s,Len(tWertL.s)-1) 
          EndIf
        Case tmsep.s
          If Len(tWertL.s) And tWertL.s <> "-"
            Result.s = Mid(tFormatL.s,tPos.w,1) + Result.s 
          EndIf
        Default
          Result.s = Mid(tFormatL.s,tPos.w,1) + Result.s 
      EndSelect 
    Next
    If tFormatR.s <> ""
      Result.s + tcomma.s
      For tPos.w = 1 To Len(tFormatR.s) Step 1 
        Select Mid(tFormatR.s,tPos.w,1) 
          Case "0" 
            If Len(tWertR.s) 
              Result.s = Result.s + Left(tWertR.s,1)
              tWertR.s = Right(tWertR.s,Len(tWertR.s)-1) 
            Else 
              Result.s = Result.s + "0" 
            EndIf 
          Case "#" 
            If Len(tWertR.s) 
              Result.s = Result.s + Left(tWertR.s,1) 
              tWertR.s = Right(tWertR.s,Len(tWertR.s)-1) 
            Else 
              Result.s = Result.s + " "
            EndIf
          Case "~"
            If Len(tWertR.s)
              If Len(tWertR.s) > 1
                Result.s = Result.s + Str(Val(Left(tWertR.s,1))+H_DoRound(Right(tWertR.s,Len(tWertR.s)-1)))
              Else
                Result.s = Result.s + Left(tWertR.s,1)
              EndIf
              tWertR.s = ""
            Else 
              Result.s = Result.s + "0"
            EndIf          
          Default
            Result.s = Result.s + Mid(tFormatR.s,tPos.w,1) 
        EndSelect 
      Next
    EndIf
  EndIf
  ProcedureReturn Result
EndProcedure 


Procedure.b H_DoRound(value.s)
  ; Hilfsfunktion zum korreken Runden
  ; value = unsichtbare Nachkomma-Zahlen die gerundet werden
  ; Rckgabe = +/- 1, die der letzten Stelle hinzuaddiert werden
  Protected dig.b,dir.b,n.b
  If Len(value.s) > 0
    For n = Len(value.s) To 1 Step -1
      dig = Val(Mid(value.s,n,1)) + dir
      If dig >= 5
        dir = 1
      Else
        dir = 0
      EndIf      
    Next
    ;dig = Val(Left(value.s,1))
    ;If dig >= 0
    ;  If dig > 5
    ;    dir.b = 1
    ;  Else
    ;    If dig < 5
    ;      dir.b = 0
    ;    Else
    ;      If Len(value.s) > 1
    ;        dir.b = H_DoRound(Right(value.s,Len(value.s)-1))
    ;      Else           
    ;        dir.b = 1 ; Wenn die letzte Stelle eine 5 ist - aufrunden
    ;      EndIf
    ;    EndIf
    ;  EndIf
    ;EndIf
  EndIf
  ProcedureReturn dir
EndProcedure



Procedure H_DrawSummary(ActX.w,ActY.w,ActWidth.w,Col.b)
  ; Hilfsfunktion zum Zeichnen der Spalten-Summe
  Protected tDatType.b, tSum.s
  If H_GetColSummaryFlag(Col.b) = 1
    tDatType = H_GetColDataType(Col.b)
    If tDatType > 0 And tDatType <> 2
      ;ActY + CSGrid()\DefGridHeight
      If CSGrid()\GridVisible = 1
        Box(ActX,ActY,ActWidth-1,CSGrid()\DefGridHeight-1,CSGrid()\Color_CaptBack)
      Else
        Box(ActX,ActY,ActWidth,CSGrid()\DefGridHeight,CSGrid()\Color_CaptBack)
      EndIf
      Line(ActX+2,ActY+4,8,0,#DefColor_ColSumSymbol)
      Line(ActX+2,ActY+CSGrid()\DefGridHeight-6,8,0,#DefColor_ColSumSymbol)
      Line(ActX+2,ActY+4,6,((CSGrid()\DefGridHeight-8)/2),#DefColor_ColSumSymbol)
      Line(ActX+2,ActY+CSGrid()\DefGridHeight-6,6,((CSGrid()\DefGridHeight-8)/-2),#DefColor_ColSumSymbol)
      FrontColor(CSGrid()\Color_CellFore) 
      If CSGrid()\Font <> 0
        DrawingFont(CSGrid()\Font)
      EndIf
      H_DrawCellContent(StrF(H_CalcColSummary(Col.b)),ActX + 2,ActY+2,ActWidth.w,tDatType)
    EndIf
  EndIf
EndProcedure


Procedure H_DrawSortSymbol(ActX.w,ActY.w,ActWidth.w,Direction.b)
  ; Hilfsfunktion zum Zeichnen des Sortierungs-Piktogramms
  Protected tx.w, ty.w, theight.b
  tx = ActX + ActWidth - (CSGrid()\DefGridHeight / 2) - 4
  ty = ActY + (CSGrid()\DefGridHeight / 2) - 4
  If Direction = -1
    Line(tx,ty,8,0,#DefColor_Symbols)
    Line(tx,ty,4,8,#DefColor_Symbols)
    Line(tx+8,ty,-4,8,#DefColor_Symbols)
  Else
    Line(tx,ty+8,8,0,#DefColor_Symbols)
    Line(tx,ty+8,4,-8,#DefColor_Symbols)
    Line(tx+8,ty+8,-4,-8,#DefColor_Symbols)
  EndIf
EndProcedure


Procedure H_DrawDetailsSymbol(ActX.w,ActY.w,ActWidth.w,Status.b)
  ; Hilfsfunktion zum Zeichnen des Expand/Collapse-Symbols der Zeilen-Details
  Protected tx.w, ty.w
  tx = ActX + ActWidth - (CSGrid()\DefGridHeight / 2) - 4
  ty = ActY + (CSGrid()\DefGridHeight / 2) - 4
  If Status = 1
    Line(tx,ty,8,0,#DefColor_Symbols)
    Line(tx,ty,4,8,#DefColor_Symbols)
    Line(tx+8,ty,-4,8,#DefColor_Symbols)  
  Else
    Line(tx,ty,0,8,#DefColor_Symbols)
    Line(tx,ty,8,4,#DefColor_Symbols)
    Line(tx,ty+8,8,-4,#DefColor_Symbols)
  EndIf  
EndProcedure


Procedure H_DrawBooleanValue(ActX.w,ActY.w,ActWidth.w,Value.b)
  ; Hilfsfunktion zum Zeichnen der Checkbox fr boolsche Werte
  Protected tx.w, ty.w, tsize.b
  tsize = CSGrid()\DefGridHeight / 2
  tx = ActX + (ActWidth / 2) - (tsize / 2)
  ty = ActY + (CSGrid()\DefGridHeight / 2) - (tsize / 2) - 3
  DrawingMode(#PB_2DDrawing_Outlined)
  Box(tx,ty,tsize,tsize,CSGrid()\Color_CellFore)
  DrawingMode(#PB_2DDrawing_Transparent)  
  If Value.b = 1
    Line(tx,ty,tsize,tsize,CSGrid()\Color_CellFore)
    Line(tx,ty+((tsize/2)*2),tsize,-tsize,CSGrid()\Color_CellFore)
  EndIf
EndProcedure


Procedure.b H_EnableDetailsObject(NoRedraw.b=-1)
  ; Hilfsfunktion zum Aktivieren von Zeilen-Details
  Protected tStat.b, tEvent.b
  If CSGrid()\RowExpand = 1 And CSGrid()\RowCaptVisible = 1 
    If H_GetRowDetailsHandle(CSGrid()\ActRowStart) <> 0
      tStat = CSGrid_Row()\DetailsVisible
      CSGrid_Row()\DetailsVisible = 1
      H_DrawScrollbars(1)
      ;CSGrid_DetailsFocusGadget = CSGrid()\hGadget
      If tStat = 1
        HideGadget(CSGrid_Row()\hDetails,1)
        H_InitShortCuts()
      Else        
        If NoRedraw < 1
          H_DrawGrid(-1)
        EndIf
        If CSGrid_Row()\DetailsIsGrid = 1
          tparent.l = CSGrid_ActGridhGadget     
          H_GetGadget(hDetails)
          CSGridGadget_SetFocus(CSGrid_Row()\hDetails)                    
          ;CSGrid_DetailsFocusGadget = CSGrid()\hGadget                    
          CSGridGadget_SetCursor(hDetails,1,1)
          CSGrid()\ParentGrid = tparent.l
          CSGrid()\Hidden = -1
          H_InitShortCuts()
        Else
          H_RemoveShortCuts(1)
        EndIf
      EndIf
      tEvent = 96 + CSGrid_Row()\DetailsVisible
    EndIf
  EndIf
  ProcedureReturn tEvent
EndProcedure


Procedure.b H_DisableDetailsObject(NoRedraw.b=-1,FocusOnParent.b=-1)
  ; Hilfsfunktion zum Deaktivieren von Zeilen-Details (wenn Subobjekt Fokus hat)
  Protected tparent.l,tchild.l, isGrid.b ;, trowID.l, tgridID.l
  If FocusOnParent = 1
    If CSGrid_Row()\DetailsIsGrid = 1
      tchild = CSGrid_Row()\hDetails
      tparent = ListIndex(CSGrid())
      isGrid = CSGrid_Row()\DetailsIsGrid
      If isGrid = 1
        ResetList(CSGrid())
        While NextElement(CSGrid())
          If CSGrid()\hGadget = tchild
            Break
          EndIf
        Wend
      EndIf
    EndIf
  EndIf
  If CSGrid()\ParentGrid > 0
    If CSGrid()\hInput <> 0
      If IsGadget(CSGrid()\hInput)
        FreeGadget(CSGrid()\hInput)
      EndIf
      CSGrid()\hInput = 0
    EndIf
    tparent.l = CSGrid()\ParentGrid
    CSGrid()\ParentGrid = 0
    CSGrid()\Hidden = 1
    H_GetGadget(tparent.l)
    CSGridGadget_SetFocus(tparent.l,1)
    H_GetRowDetailsHandle(CSGrid()\ActRowEnd) 
    If NoRedraw < 1
      H_DrawGrid(1)
    EndIf
  EndIf
  If CSGrid()\RowExpand = 1 And CSGrid()\RowCaptVisible = 1 
    If H_GetRowDetailsHandle(CSGrid()\ActRowStart) <> 0
      If CSGrid_Row()\DetailsVisible = 1
        CSGrid_Row()\DetailsVisible = -1
        ;CSGrid_DetailsFocusGadget = 0
        HideGadget(CSGrid_Row()\hDetails,1)
        H_InitShortCuts()
        H_DrawScrollbars(1)
        tEvent = 96 + CSGrid_Row()\DetailsVisible
        If NoRedraw < 1
          H_DrawGrid(-1)
        EndIf
      EndIf
    EndIf
  EndIf
  ProcedureReturn tEvent
EndProcedure


Procedure H_DisableAlleDetailObjects()
  ; Hilfsfunktion zum Schlieen/Deaktivieren smtlicher Sub-Gadgets in einem Grid (mit Fokus vom Parent Grid aus)
  ResetList(CSGrid_Row())
  While NextElement(CSGrid_Row())
    If CSGrid_Row()\DetailsVisible = 1 And CSGrid_Row()\hGadget = CSGrid()\hGadget
      If CSGrid_Row()\DetailsIsGrid = 1
        H_DisableDetailsObject(1,1)
      Else
        HideGadget(CSGrid_Row()\hDetails,1)
        H_InitShortCuts()
      EndIf
      Break
    EndIf
  Wend  
EndProcedure


Procedure H_PositionDetailsObject(ActX.w,ActY.w,theight.w,Status.b,hDetails.l)
  ; Hilfsfunktion zum Zeichnen/Positionieren des Zeilen-Details-Objektes
  Protected twidth.w,tleft.w,ttop.w
  If IsGadget(hDetails)
    If Status.b = 1
      ActX = ActX + ActWidth - (CSGrid()\DefGridHeight / 2) - 4
      twidth = GadgetWidth(hDetails)
      If twidth > (CSGrid()\ImgWidth - ActX - CSGrid()\RowCaptWidth - 2)
        twidth = CSGrid()\ImgWidth - ActX - CSGrid()\RowCaptWidth - 2
      EndIf
      If twidth < 0
        twidth = 0
      EndIf
      If (ActY+theight) > CSGrid()\ImgHeight
        theight = CSGrid()\ImgHeight - ActY
      EndIf
      If theight < 0
        theight = 0
      EndIf
      If twidth > 0 And theight > 0
        ttop = CSGrid()\top + ActY + 1
        tleft = CSGrid()\left + ActX + CSGrid()\RowCaptWidth + 1
        If tleft <> GadgetX(hDetails) Or ttop <> GadgetY(hDetails) Or twidth <> GadgetWidth(hDetails) Or theight <> GadgetHeight(hDetails)
          If CSGrid_Row()\DetailsIsGrid = 1
            CSGridGadget_Resize(hDetails,tleft,ttop,twidth,theight,1)
          Else
            ResizeGadget(hDetails,tleft,ttop,twidth,theight)
          EndIf
        EndIf
        HideGadget(hDetails,0)
        SetActiveGadget(hDetails)
      Else
        HideGadget(hDetails,1)
      EndIf
    Else
      HideGadget(hDetails,1)
    EndIf
  EndIf
EndProcedure


Procedure.f H_CalcColSummary(Col.b)
  ; Hilfsfunktion zum Kalkulieren der Spalten-Summe
  Protected tRow.w, tSum.f
  For tRow = 0 To CSGrid()\Rows-1
    tSum.f = tSum.f + ValF(H_GetCellValue(Col.b,tRow.w))
  Next
  If H_CheckIfColSetExists(Col.b) = 1
    CSGrid_Col()\sumval = tSum.f
  EndIf
  ProcedureReturn tSum
EndProcedure


Procedure H_SwapRowContent(sRow.w,dRow.w)
  ; Hilfsfunktion zum Verschieben des Inhaltes einer kompletten Zeile in eine andere Zeile
  Protected tCol.b,sElement.l, dElement.l
  For tCol.b = 0 To CSGrid()\Cols-1
    H_GetCell(tCol.b,sRow.w)
    *sElement = @CSGrid_Cell()
    H_GetCell(tCol.b,dRow.w)
    *dElement = @CSGrid_Cell()
    SwapElements(CSGrid_Cell(),*sElement,*dElement)
  Next  
EndProcedure


Procedure H_DoColSorting(Col.b,Dir.b)
  ; Hilfsfunktion zum Sortieren des Grids nach einer speziellen Spalte
  ; Dir.b: 1 = aufsteigend, -1 = absteigend
  Protected tRow.w, sStr.s, dStr.s, sVal.f, dVal.f, tMode.b, tSwap.b
  If (Dir.b = 1 Or Dir.b = -1) And Col.b >= 0 And Col.b <= CSGrid()\Cols-1
    tMode = H_GetColDataType(Col.b)
    CSGrid()\SortCol = Col.b
    CSGrid()\SortDir = Dir.b
    Repeat
      tSwap = 0
      For tRow.w = 0 To CSGrid()\Rows-1 
        If (tRow.w+1) >= 0 And (tRow.w+1) <= CSGrid()\Rows-1
          sStr.s = H_GetCellValue(Col.b,tRow.w)
          dStr.s = H_GetCellValue(Col.b,tRow.w+1)
          If tMode > 0 
            sVal = ValF(sStr)
            dVal = ValF(dStr)
            If (sVal > dVal And Dir = 1) Or (sVal < dVal And Dir = -1)
              H_SwapRowContent(tRow.w,tRow.w+1)
              tSwap = 1
            EndIf        
          Else
            If (sStr > dStr And Dir = 1) Or (sStr < dStr And Dir = -1)
              H_SwapRowContent(tRow.w,tRow.w+1)
              tSwap = 1
            EndIf
          EndIf
        EndIf
      Next
    Until tSwap = 0
  EndIf
EndProcedure


Procedure H_CreateSelListEntries(tRessource.s,tType.b,tActValue.s)
  ; Hilfsfunktion zum Erstellen der List-Eintrge fr die List-Selektion
  Protected tpos.l, tline.s,lpos.w
  Select tType.b ; 32=Rollup mit Wertliste, 33=Rollup mit Wertliste 2-spaltig, 64=Rollup mit SQL-String, 65=Rollup mit SQL-String 2-spaltig
    Case 64 ; SQL-Abfrage
    Case #CSGRID_Input_Rollup,#CSGRID_Input_Combo ; Werteliste, einspaltig
      While Len(tRessource.s) > 0
        tpos = FindString(tRessource.s,Chr(13) + Chr(10),1)
        If tpos > 0
          tline = Left(tRessource,tpos-1)
          tRessource = Right(tRessource,Len(tRessource)-tpos-1)
        Else
          tline = tRessource 
          tRessource = ""
        EndIf
        If tline <> ""
          AddGadgetItem(CSGrid()\hInput,-1,tline)
          If tActValue.s = tline
            lpos = CountGadgetItems(CSGrid()\hInput)
          EndIf
        EndIf
      Wend
  EndSelect
  If lpos > 0
    SetGadgetState(CSGrid()\hInput,lpos-1)
  EndIf
EndProcedure
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 2467
; FirstLine = 2419
; Folding = ----------------------------
; EnableXP
; EnableOnError
; Executable = OpenSource\CS-Grid2.exe